;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@                                                                            @
;@                                S y m  A m p                                @
;@                                                                            @
;@             (c) 2005-2007 by Prodatron / SymbiosiS (Jrn Mika)             @
;@                                                                            @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

relocate_start

;todo
;+ zeit bei gren MP3s korrekt anzeigen (CTLTUP)
;+ hauptprozess hngt sich manchmal bei songlist-add auf -> keine message von system-manager
;- mp3 titel statt filename zeigen
;- ayc support
;- Play bei voller Playliste und leerem Play -> erstes Stck aus Playliste holen
;- Liste sortieren
;- mousewheel liste klappt nicht
;- ST2 auf turboR + korrektur
;- spl songlist auch als startparameter

;==============================================================================
;### CODE-TEIL ################################################################
;==============================================================================

;### PROGRAMM-KOPF ############################################################

prgdatcod       equ 0           ;Lnge Code-Teil (Pos+Len beliebig; inklusive Kopf!)
prgdatdat       equ 2           ;Lnge Daten-Teil (innerhalb 16K Block)
prgdattra       equ 4           ;Lnge Transfer-Teil (ab #C000)
prgdatorg       equ 6           ;Original-Origin
prgdatrel       equ 8           ;Anzahl Eintrge Relocator-Tabelle
prgdatstk       equ 10          ;Lnge Stack (Transfer-Teil beginnt immer mit Stack)
prgdatrsv       equ 12          ;*reserved* (3 bytes)
prgdatnam       equ 15          ;program name (24+1[0] chars)
prgdatflg       equ 40          ;flags (+1=16colour icon available)
prgdat16i       equ 41          ;file offset of 16colour icon
prgdatrs2       equ 43          ;*reserved* (5 bytes)
prgdatidn       equ 48          ;"SymExe10"
prgdatcex       equ 56          ;zustzlicher Speicher fr Code-Bereich
prgdatdex       equ 58          ;zustzlicher Speicher fr Data-Bereich
prgdattex       equ 60          ;zustzlicher Speicher fr Transfer-Bereich
prgdatres       equ 62          ;*reserviert* (26 bytes)
prgdatver       equ 88          ;required OS version (1.0)
prgdatism       equ 90          ;Icon (klein)
prgdatibg       equ 109         ;Icon (gross)
prgdatlen       equ 256         ;Datensatzlnge

prgpstdat       equ 6           ;Adresse Daten-Teil
prgpsttra       equ 8           ;Adresse Transfer-Teil
prgpstspz       equ 10          ;zustzliche Prozessnummern (4*1)
prgpstbnk       equ 14          ;Bank (1-8)
prgpstmem       equ 48          ;zustzliche Memory-Bereiche (8*5)
prgpstnum       equ 88          ;Programm-Nummer
prgpstprz       equ 89          ;Prozess-Nummer

prgcodbeg   dw prgdatbeg-prgcodbeg  ;Lnge Code-Teil
            dw prgtrnbeg-prgdatbeg  ;Lnge Daten-Teil
            dw prgtrnend-prgtrnbeg  ;Lnge Transfer-Teil
prgdatadr   dw #1000                ;Original-Origin                    POST Adresse Daten-Teil
prgtrnadr   dw relocate_count       ;Anzahl Eintrge Relocator-Tabelle  POST Adresse Transfer-Teil
prgprztab   dw prgstk-prgtrnbeg     ;Lnge Stack                        POST Tabelle Prozesse
            dw 0                    ;*reserved*
prgbnknum   db 0                    ;*reserved*                         POST Bank-Nummer
            db "SymAmp":ds 18:db 0  ;Name
            db 1                    ;flags (+1=16c icon)
            dw prgicn16c-prgcodbeg  ;16 colour icon offset
            ds 5                    ;*reserved*
prgmemtab   db "SymExe10"           ;SymbOS-EXE-Kennung                 POST Tabelle Speicherbereiche
            dw sndmax               ;zustzlicher Code-Speicher
            dw 0                    ;zustzlicher Data-Speicher
            dw lstmax               ;zustzlicher Transfer-Speicher
            ds 26                   ;*reserviert*
            db 0,2                  ;required OS version (2.0)
prgicnsml   db 2,8,8,#10,#E6,#21,#CC,#53,#AC,#B7,#FE,#F7,#DE,#53,#AC,#33,#48,#76,#80
prgicnbig   db 6,24,24
            db #00,#00,#10,#80,#00,#60,#00,#00,#31,#C8,#00,#A4,#00,#00,#63,#6C,#30,#6C,#00,#00,#C7,#3E,#43,#EC,#00,#10,#8F,#1E,#95,#48,#00,#31,#0F,#3D,#3B,#80,#00,#63,#0F,#E3,#56,#00,#00,#C7,#1E,#CE,#FC,#00
            db #10,#8F,#79,#9F,#5B,#80,#31,#0F,#F7,#3F,#C3,#C8,#63,#3C,#8F,#3F,#E1,#6C,#C7,#4B,#00,#7E,#ED,#3E,#C7,#6B,#09,#F9,#6D,#3E,#63,#7B,#1B,#F7,#C3,#6C,#31,#3C,#34,#DE,#0F,#C8,#10,#AC,#7B,#69,#1F,#80
            db #00,#D4,#D7,#87,#3E,#00,#00,#BD,#FC,#0F,#6C,#00,#10,#FF,#4B,#0F,#C8,#00,#31,#DE,#87,#1F,#80,#00,#73,#6C,#C7,#3E,#00,#00,#73,#C0,#63,#6C,#00,#00,#52,#00,#31,#C8,#00,#00,#60,#00,#10,#80,#00,#00

;### Config
anaflg  db 1
ctlrepf db 1
ctlshuf db 0
lstwin  db -1   ;Nummer des Songlist-Fensters (>0 -> aktiviert, =0 -> nicht aktiviert)
mixwin  db -1   ;Nummer des Mixer-Fensters (-1 = nicht offen)

prgid   db "SymAmp":ds 6

;### PRGPRZ -> Programm-Prozess
dskprzn     db 2
sysprzn     db 3
windatprz   equ 3   ;Prozenummer
windatsup   equ 51  ;Nummer des Superfensters+1 oder 0
prgwin      db 0    ;Nummer des Haupt-Fensters
diawin      db -1   ;Nummer des Dialog-Fensters

prgprz  call SySystem_HLPINI
        call prgdbl
        ld a,(prgprzn)
        ld (prgwindat+windatprz),a
        ld (prglstdat+windatprz),a
        ld (properwin+windatprz),a
        ld (prgwinmix+windatprz),a

        call sysini             ;Computer-Typ abhngige Initialisierung
        call gfxini             ;Grafiken aus "Skin" kopieren
        call lstini
        call lstupd0
        ld a,(lstwin)           ;Songliste optional anzeigen
        or a
        ld a,0
        ld (lstwin),a
        call nz,lstopn
        call cfgini

        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwindat
        call msgsnd             ;Fenster aufbauen
prgprz1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgend             ;kein Speicher fr Fenster -> Proze beenden
        cp MSR_DSK_WOPNOK
        jr nz,prgprz1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (prgwin),a           ;Fenster wurde geffnet -> Nummer merken

        ld hl,prgtims           ;Timer hinzufgen
        ld a,(prgbnknum)
        call SyKernel_MTADDT
        jp c,prgend
        ld (prgprztab+0),a

        jp sndpar

prgprz0 call msgget
        jr nc,prgprz0
        ld b,a
        ld a,(prgtimn)
        db #dd:cp h
        jp z,ctlinc             ;*** Message vom eigenen Timer bekommen
        ld a,b
        cp MSC_GEN_FOCUS        ;*** Application soll sich Focus nehmen
        jp z,prgfoc0
        cp MSR_DSK_WFOCUS
        jr z,prgfoc
        cp MSR_DSK_WCLICK       ;*** Fenster-Aktion wurde geklickt
        jr nz,prgprz0
        ld e,(iy+1)
        ld a,(prgwin)
        cp e
        jr z,prgprz4
        ld a,(lstwin)
        cp e
        jr nz,prgprz6
        ld a,(iy+2)
        cp DSK_ACT_CLOSE
        jp z,lstswt
        jr prgprz7
prgprz6 ld a,(mixwin)           ;*** MIXER-FENSTER
        cp e
        jr nz,prgprz8
        ld a,(iy+2)
        cp DSK_ACT_CLOSE
        jr nz,prgprz5
        jp mixclo
prgprz8 ld a,(diawin)
        cp e
        jr nz,prgprz0
        ld a,(iy+2)             ;*** DIALOG-FENSTER
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,diacnc
        jr prgprz5
prgprz4 ld a,(iy+2)             ;*** HAUPT-FENSTER ODER SONGLIST
        cp DSK_ACT_CLOSE        ;*** Close wurde geklickt
        jp z,prgend
prgprz7 cp DSK_ACT_KEY          ;*** Taste wurde gedrckt
        jp z,prgkey
prgprz5 cp DSK_ACT_MENU         ;*** Men wurde geklickt
        jr z,prgprz2
        cp DSK_ACT_CONTENT      ;*** Inhalt wurde geklickt
        jr nz,prgprz0
prgprz2 ld l,(iy+8)
        ld h,(iy+9)
        ld a,l
        or h
        jr z,prgprz0
        ld a,(iy+3)             ;A=Klick-Typ (0/1/2=Maus links/rechts/doppelt, 7=Tastatur)
        jp (hl)

;### PRGFOC -> Focus-nderung von Hauptfenster verarbeiten
prgfoc  ld e,(iy+1)
        ld a,(prgwin)
        cp e
        jp nz,prgprz0
        ld a,(prgwindat)
        cp 3
        jr nz,prgfoc1
        ld a,(lstwin)
        or a
        jp z,prgprz0
        ld c,MSC_DSK_WINMIN
        call ctlsta2
        jp prgprz0
prgfoc1 ld a,(prglstdat)
        cp 3
        jp nz,prgprz0
        ld a,(lstwin)
        or a
        jp z,prgprz0
        ld c,MSC_DSK_WINMID
        call ctlsta2
prgfoc2 ld a,(prgwin)
        ld c,MSC_DSK_WINTOP
        call ctlsta2
        jp prgprz0
prgfoc0 ld a,(prgwin)
        ld b,a
        ld c,MSC_DSK_WINMID
        call msgsnd
        jr prgfoc1

;### PRGKEY -> Taste auswerten
prgkeya equ 24
prgkeyt db "Z":dw ctlrew    ;Z=Rckwrts
        db "X":dw ctlply    ;X=Play
        db "C":dw ctlpau    ;C=Pause
        db "V":dw ctlstp    ;V=Stop
        db "B":dw ctlffw    ;B=Vorwrts
        db "L":dw ctlopn    ;L=Laden
        db "R":dw ctlrep    ;R=Repeat
        db "S":dw ctlshu    ;S=Shuffle
        db 139:dw ctlskf    ;->=skip forward
        db 138:dw ctlskb    ;<-=skip backward
        db 136:dw ctlvlu    ;up=increase volume
        db 137:dw ctlvld    ;dw=decrease volume
        db 156:dw lstswt    ;Alt+E=Playlist
        db "A":dw lstafi    ;A=Add file
        db 152:dw lstadi    ;Alt+A=Add folder
        db 008:dw lstrsl    ;Del=Remove Selected
        db 127:dw lstral    ;Clr=Remove All
        db 001:dw lstsal    ;Ctrl+A=Select All
        db 014:dw lstsno    ;Ctrl+N=Select None
        db 160:dw lstsiv    ;Alt+I=Invert Selection
        db "U":dw lsteup    ;U=Up
        db "D":dw lstedw    ;D=Down
        db 015:dw lstlod    ;Ctrl+O=Load Playlist
        db 019:dw lstsav    ;Ctrl+S=Save Playlist

prgkey  ld hl,prgkeyt
        ld b,prgkeya
        ld de,3
        ld a,(iy+4)
        call clcucs
prgkey1 cp (hl)
        jr z,prgkey2
        add hl,de
        djnz prgkey1
        jp prgprz0
prgkey2 inc hl
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld a,7
        jp (hl)

;### PRGEND -> Programm beenden
prgend  call sndstp
        call mp3del
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        ld (iy+0),MSC_SYS_PRGEND
        ld a,(prgcodbeg+prgpstnum)
        ld (iy+1),a
        rst #10
prgend0 rst #30
        jr prgend0

;### PRGINF -> Info-Fenster anzeigen
prginf  ld hl,prgmsginf         ;*** Info-Fenster
        ld b,1+128
        call prginf0
        jp prgprz0
prginf0 ld (prgmsgb+1),hl
        ld a,(prgbnknum)
        ld c,a
        ld (prgmsgb+3),bc
        ld a,MSC_SYS_SYSWRN
        ld (prgmsgb),a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        ld iy,prgmsgb
        rst #10
        ret

;### PRGERR -> Disc-Error-Fenster anzeigen
prgerr  ret nc
        call clcdez
        ld (sysmsglod2a),hl
        ld b,1
        ld hl,prgmsgerr
        jr prginf0

;### PRGDBL -> Test, ob Programm bereits luft
prgdbl  xor a
        ld (prgcodbeg+prgdatnam),a
        ld hl,prgid
        ld b,l
        ld e,h
        ld l,a
        ld c,MSC_SYS_PRGSRV
        ld a,(prgbnknum)
        ld d,a
        ld a,PRC_ID_SYSTEM
        call msgsnd1
prgdbl1 db #dd:ld h,PRC_ID_SYSTEM
        call msgget1
        jr nc,prgdbl1
        cp MSR_SYS_PRGSRV
        jr nz,prgdbl1
        ld a,"S"
        ld (prgcodbeg+prgdatnam),a
        ld a,(prgmsgb+1)
        or a
        ret nz
        ld a,(prgmsgb+9)
        ld c,MSC_GEN_FOCUS
        call msgsnd1
        jp prgend


;==============================================================================
;### SONG-INFO ################################################################
;==============================================================================

;### PRPLST -> Infos ber Listeneintrag anzeigen
prplst  ld ix,lstentlst
        ld hl,lstmem+4
        ld a,(prgobjlst1)
        or a
        jp z,prgprz0
        ld bc,4
        ld de,17
prplst1 bit 7,(ix+1)
        jr nz,prplst2
        add hl,de
        add ix,bc
        dec a
        jr nz,prplst1
        jp prgprz0
prplst2 push hl
        ld hl,lstpth
        ld de,propertxt10
        call prpinf3
        pop hl
        call prpinf3
        ld a,8
        call prpinf
        jr prpopn

;### PRPSNG -> Infos ber geladenen Song anzeigen
prpsng  ld a,(sndinif)
        or a
        jp z,prgprz0
        ld hl,sndfil
        ld de,propertxt10
        call prpinf3
        ld a,19
        call prpinf
;### PRPOPN -> Songinfo-Fenster ffnen
prpopn  ld de,properwin
        jp diaopn

;### PRPLST -> Song-Infos generieren
;### Eingabe    A=Anzahl Objekte von Property-Fenster, DE=letztes Filenamen-Zeichen
prpinft db "skmst2mp3pt3",0
prpinfa dw propertxt2x,propertxt20,propertxt21,propertxt22,propertxt24

prpinf  ld (propergrp),a
        ld ix,-4
        add ix,de
        ld iy,prpinft
        ld c,0
        ld a,(ix+0)
        cp "."
        jr nz,prpinf6
        ld de,3
        ld b,1
prpinf7 ld a,(iy+0)
        or a
        jr z,prpinf6
                    cp (ix+1):jr nz,prpinf4
        ld a,(iy+1):cp (ix+2):jr nz,prpinf4
        ld a,(iy+2):cp (ix+3):jr z,prpinf5
prpinf4 add iy,de
        inc b
        jr prpinf7
prpinf5 ld c,b
prpinf6 ld b,0
        ld hl,prpinfa
        add hl,bc
        add hl,bc
        ld a,(hl)
        inc hl
        ld h,(hl)
        ld l,a
        ld (properdsc2b),hl
        ld a,c
        cp 3
        ld hl,propertxt2y
        jr nz,prpinf8
        ld hl,propertxt23
prpinf8 ld (properdsc2c),hl
        ret
prpinf3 ld a,(hl)
        ldi
        or a
        jr nz,prpinf3
        dec de
        ret


;==============================================================================
;### SPECTRUM ANALYZER ########################################################
;==============================================================================

anatab  ds 10,1     ;Volume-Tabelle (1-13) fr alle 16/10 Frequenzen
anatab0 ds 10,1

;### ANASWT -> Analyzer an-/ausschalten
anaswt  ld a,(anaflg)
        xor 1
        ld (anaflg),a
        call z,anaoff
        jp prgprz0

;### ANAOFF -> Analyzer lschen
anaoff  ld hl,anatab
        ld de,anatab+1
        ld (hl),1
        ld bc,10+10-1
        ldir
        ld hl,gfxana0+3
        ld de,gfxana1+3
        ld bc,12*10
        ldir
        jr anaplt1

;### ANAPLT -> Plottet Analyzer
anaplt  call anaupd
        ret z
anaplt1 ld e,14
        jp ctlsta1

;### ANAUPD -> Analyzer-Grafik updaten
;### Ausgabe    ZF=1 keine nderung stattgefunden
anaupdf db 0                    ;Flag, ob nderung

anaupd  xor a
        ld (anaupdf),a
        ld hl,anatab            ;alte Lautstrken verringern
        ld b,10
anaupd1 dec (hl)
        jr nz,anaupd2
        inc (hl)
anaupd2 inc hl
        djnz anaupd1
        ld a,0
anaupd8 dec a                   ;neue Lautstrken eintragen
        push af
        call anaupd7
        pop af
        jr nz,anaupd8
        ld hl,anatab            ;Grafik mit Differenzen updaten
        ld de,anatab0
        ld b,10
anaupd3 ld a,(de)
        ld c,(hl)
        ldi
        inc c
        sub c
        jr z,anaupd4
        push hl
        push de
        push bc
        ld hl,gfxana0+3
        jr nc,anaupd5
        ld hl,gfxana2+3
        ld d,a
        add c
        ld c,a
        ld a,d
        neg             ;C=Start von unten, A=Lnge
anaupd5 ld d,a          ;D=Lnge
        ld a,13
        sub c           ;A=Start-Position (0-12)
        add a
        ld c,a
        add a
        add a
        add c
        ld c,a          ;C=Y*10
        ld a,10
        sub b
        add c
        ld c,a          ;C=Y*10+X=Offset
        ld b,0          ;BC=Offset
        ld a,d          ;A=Lnge
        ex de,hl
        ld hl,gfxana1+3
        add hl,bc
        ex de,hl        ;DE=Zielgrafik
        add hl,bc       ;HL=Quellgrafik
        ld (anaupdf),a
anaupd6 ldi
        ld bc,-11
        add hl,bc
        ex de,hl
        add hl,bc
        ex de,hl
        dec a
        jr nz,anaupd6
        pop bc
        pop de
        pop hl
anaupd4 djnz anaupd3
        ld a,(anaupdf)
        or a
        ret
anaupd7 call sndchn
        ld c,a
        add a
        add c
        add a:add a             ;A=A*12
        srl a:srl a:srl a:srl a ;A=A*12/16
        inc a
        ld e,a
        ld a,l
        add a:add a:add l:add a ;A=A*10
        srl a:srl a:srl a:srl a ;A=A*10/16
        ld l,a
        ld h,0
        ld bc,anatab
        add hl,bc
        ld (hl),e
        ret


;==============================================================================
;### PLAY-LIST ################################################################
;==============================================================================

;### LSTINI -> Playliste initialisieren
lstini  ld de,lstmem
        ld b,0
        ld a,99
        ld ix,lstentlst
lstini1 ld (ix+2),e
        ld (ix+3),d
        ld c,a
        neg
        add 100
        call clcdez
        ld a,c
        ex de,hl
        ld (hl),e
        inc hl
        ld (hl),d
        ld c,16
        add hl,bc
        ex de,hl
        ld c,4
        add ix,bc
        dec a
        jr nz,lstini1
        ret

;### LSTOPN -> ffnet Playlist
lstopn  ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prglstdat
        call msgsnd             ;Fenster aufbauen
lstopn1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        ccf
        ret z
        cp MSR_DSK_WOPNOK
        jr nz,lstopn1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (lstwin),a           ;Fenster wurde geffnet -> Nummer merken
        ld hl,prgwinmen4+2
        set 1,(hl)
        or a
        ret

;### LSTSWT -> Schaltet Playliste an/aus
lstswt  ld a,(lstwin)
        or a
        jr nz,lstswt1
        call lstopn
        jp c,prgprz0
        jp prgfoc2
lstswt1 ld c,MSC_DSK_WINCLS
        call ctlsta2
        xor a
        ld (lstwin),a
        ld hl,prgwinmen4+2
        res 1,(hl)
        jp prgprz0

;### LSTUPD -> Baut Liste neu auf inklusive Gre
lstupd  call lstupd0
        ld a,(lstwin)
        ld c,MSC_DSK_WINSLD
        call ctlsta2
        ld a,(lstwin)
        ld c,MSC_DSK_WINDIN
        ld e,0
        jp ctlsta2
lstupd0 ld a,(prgobjlst1)
        add a
        jr nz,lstupd1
        ld a,2
lstupd1 ld l,a
        ld h,0
        add hl,hl
        add hl,hl
        inc hl
        inc hl
        ld (prglstobj+16+12),hl
        ld (prglstclc+16+12),hl
        ld (prglstdat+18),hl
        ret

;### LSTREF -> Baut Liste neu auf
lstref  ld e,1
        ld c,MSC_DSK_WINDIN
        ld a,(lstwin)
        jp ctlsta2

;### LSTRSL -> Entfernt selektierte Eintrge
lstrsl  ld hl,lstmem
        ld e,l
        ld d,h
        ld ix,lstentlst+1
        ld a,(prgobjlst1)
        or a
        jp z,prgprz0
        db #fd:ld h,a
        db #fd:ld l,0
lstrsl1 ld bc,17
        bit 7,(ix+0)
        jr z,lstrsl2
        add hl,bc
        db #fd:inc l
        jr lstrsl3
lstrsl2 ldir
lstrsl3 ld bc,4
        add ix,bc
        db #fd:dec h
        jr nz,lstrsl1
        db #fd:sub l
        ld (prgobjlst1),a
        call lstini
        call lstupd
        jr lstsno

;### LSTRAL -> Entfernt alle Eintrge
lstral  xor a
        ld (prgobjlst1),a
        call lstral1
        jp prgprz0
lstral1 call lstupd
        jp lstref

;### LSTSAL -> Selektiert alle Eintrge
lstsal  ld hl,lstentlst+1
        ld b,99
        ld de,4
lstsal1 set 7,(hl)
        add hl,de
        djnz lstsal1
        call lstref
        jp prgprz0

;### LSTSNO -> Deselektiert alle Eintrge
lstsno  ld hl,lstentlst+1
        ld b,99
        ld de,4
lstsno1 res 7,(hl)
        add hl,de
        djnz lstsno1
        call lstref
        jp prgprz0

;### LSTSIV -> Invertiert Selektion
lstsiv  ld hl,lstentlst+1
        ld b,99
        ld de,4
lstsiv1 ld a,(hl)
        xor 128
        ld (hl),a
        add hl,de
        djnz lstsiv1
        call lstref
        jp prgprz0

;### LSTEUP -> Selektierte Eintrge einen Platz nach oben
lsteupb ds 17
lsteup  ld a,(prgobjlst1)
        sub 1
        jp c,prgprz0
        jp z,prgprz0
        ld hl,lstmem
        ld ix,lstentlst+4
        ld b,0
lsteup1 bit 7,(ix+1)
        jr z,lsteup2
        bit 7,(ix-3)
        jr nz,lsteup3
        res 7,(ix+1)
        set 7,(ix-3)
lsteup3 push hl
        ld de,lsteupb
        ld c,17
        ldir
        pop de
        push de
        ld c,17
        ldir
        ld hl,lsteupb
        ld c,17
        ldir
        pop hl
lsteup2 ld c,17
        add hl,bc
        ld c,4
        add ix,bc
        dec a
        jr nz,lsteup1
        call lstini
        call lstref
        jp prgprz0

;### LSTEDW -> Selektierte Eintrge einen Platz nach unten
lstedw  ld a,(prgobjlst1)
        sub 1
        jp c,prgprz0
        jp z,prgprz0
        ld c,a
        ld b,0
        add a
        ld l,a
        ld h,b
        add hl,hl
        ex de,hl
        ld ix,lstentlst-4
        add ix,de
        ex de,hl
        add hl,hl
        add hl,hl
        add hl,bc
        ld de,lstmem-17
        add hl,de
        ld a,c
lstedw1 bit 7,(ix+1)
        jr z,lstedw2
        bit 7,(ix+5)
        jr nz,lstedw3
        res 7,(ix+1)
        set 7,(ix+5)
lstedw3 push hl
        ld de,lsteupb
        ld c,17
        ldir
        pop de
        push de
        ld c,17
        ldir
        ld hl,lsteupb
        ld c,17
        ldir
        pop hl
lstedw2 ld de,-17
        add hl,de
        ld de,-4
        add ix,de
        dec a
        jr nz,lstedw1
        call lstini
        call lstref
        jp prgprz0

;### LSTAFI -> Fgt Datei hinzu
lstafim db 0                    ;0=Datei hinzufgen, 1=Verzeichnis hinzufgen
lstafi  ld c,0
        ld a,(prgobjlst1)
        cp 99
        jp z,prgprz0
lstafi4 ld a,c
        ld (lstafim),a
        ld hl,lstmsk
        ld a,(prgbnknum)
        rrc c
        or c
        ld c,8
        ld ix,200
        ld iy,4000
        ld de,prgwindat
        call SySystem_SELOPN
        or a
        jp nz,prgprz0
        call lstafi0
        jp prgprz0
lstafi0 ld hl,lstfil
        push hl
        call ctlnam0            ;HL=Pfad -> HL=Name=Pfadende+2
        pop de                  ;DE=Pfad
        push hl
        or a
        sbc hl,de
        ld c,l
        pop hl
        ret z                   ;kein Pfad gefunden -> Fehler, nicht hinzufgen
        push hl
        ld hl,lstpth
        ld b,c
        ld a,(lstafim)
        or a
        jr nz,lstafi2
lstafi1 ld a,(de)
        cp (hl)
        jr nz,lstafi2           ;Pfad stimmt nicht berein, Liste leeren, neuen Pfad bernehmen
        inc hl
        inc de
        djnz lstafi1
        ld a,(hl)
        or a
        jr z,lstafi3            ;Pfad stimmt berein
lstafi2 ld de,lstpth            ;*** Pfad gendert -> neuen Pfad bernehmen und Liste leeren, bevor File hinzugefgt wird
        ld hl,lstfil
        xor a
        ld (prgobjlst1),a
        ld b,a
        ldir
        ld (de),a
lstafi3 pop bc                  ;*** File hinzufgen
        ld d,a
        ld a,(lstafim)
        or a
        jr nz,lstadi1
        call lstafi5
        jp lstral1
;BC=File -> hinzufgen
lstafi5 ld hl,prgobjlst1
        ld a,(hl)
        inc (hl)
        ld e,a
        add a
        ld l,a
        ld h,d
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,de
        ld a,e
        ld de,lstmem
        add hl,de
        ex de,hl
        inc a
        call clcdez
        ex de,hl
        ld (hl),e  :inc hl
        ld (hl),d  :inc hl
        ld (hl),".":inc hl
        ld (hl)," ":inc hl
        ex de,hl
        ld l,c
        ld h,b
        ldi
        ld b,12
lstafi6 ld a,(hl)
        call clclcs
        ld (de),a
        inc hl
        inc de
        djnz lstafi6
        ret

;### LSTADI -> Fgt Verzeichnis hinzu
dirmsk  db "skmst2binmp3pt3",0
lstadib ds 32
lstadi  ld c,1
        jp lstafi4
lstadi1 xor a                   ;*** Speicher fr Dir reservieren
        ld e,a
        ld bc,4000
        push bc
        rst #20:dw jmp_memget
        pop bc
        jp c,prgprz0
        ld (prgmemtab+0),a
        ld (prgmemtab+1),hl
        ld (prgmemtab+3),bc
        ex de,hl                ;*** Directory laden
        ld hl,lstpth
        ld ix,(prgbnknum-1)
        db #dd:ld l,16
        ld iy,0
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_DIRINP
        jp c,lstadi0
        ld b,l              ;B=Anzahl Eintrge
        ld hl,(prgmemtab+1) ;HL=Zeiger auf Daten
lstadi2 push bc
        push hl
        ld de,lstadib           ;*** Eintrag aus Directory holen
        ld a,(prgmemtab+0)
        ld c,a
        ld a,(prgbnknum)
        add a:add a:add a:add a
        add c
        ld bc,32
        rst #20:dw jmp_bnkcop

        ld hl,lstadib+9         ;*** Test, ob untersttzte Erweiterung
lstadx1 ld a,(hl)
        inc hl
        or a
        jr z,lstadi6    ;kein Punkt gefunden -> kein Extension, also kein gltiges File
        cp "."
        jr nz,lstadx1
        push hl
        pop ix
        ld hl,dirmsk-1
lstadx3 inc hl
        ld a,(hl)       ;Test, ob gltige Filemaske
        or a
        jr z,lstadi6    ;keine gltige Filemaske gefunden -> Ende
        ld c,a
        inc hl
        ld b,(hl)
        inc hl
        ld a,(ix+2)
        call clclcs
        cp (hl)
        jr nz,lstadx3
        ld a,(ix+0)
        call clclcs
        cp c
        jr nz,lstadx3
        ld a,(ix+1)
        call clclcs
        cp b
        jr nz,lstadx3

        ld bc,lstadib+9         ;*** gltigen Eintrag Liste hinzufgen
        ld d,0
        call lstafi5
lstadi6 ld hl,lstadib+9
        call strlen
        ld hl,9+1
        add hl,bc
        pop bc
        add hl,bc
        pop bc
        ld a,(prgobjlst1)
        cp 99
        jr z,lstadi5
        djnz lstadi2
lstadi5 xor a
        ld (prgobjlst1+12),a
        ld l,a
        ld h,a
        ld (prglstdat+14),hl
        call lstadi0
        jp lstral1
lstadi4 call lstadi0
        jp prgprz0
lstadi0 ld a,(prgmemtab+0)
        ld hl,(prgmemtab+1)
        ld bc,4000
        rst #20:dw jmp_memfre
        xor a
        ld l,a
        ld h,a
        ld (prgmemtab+0),a
        ld (prgmemtab+1),hl
        ld (prgmemtab+3),hl
        ret

;### LSTCLK -> Doppelklick auf die Songliste
lstclk  cp 2
        jp nz,prgprz0
lstclk1 call lstakt
        jp c,prgprz0
        jp ctlopn1

;### LSTCHK -> Prft, ob Liste Eintrge hat
;### Ausgabe    ZF=0 Liste hat Eintrge, A=Anzahl
lstchk  ld a,(prgobjlst1)
        or a
        scf
        ret

;### LSTNXT -> Holt Pfad des nchsten Eintrages in der Playliste
;### Ausgabe    CF=0 -> (sndfil)=File, ZF=1 wieder am Anfang
;###            CF=1 -> kein Eintrag vorhanden
lstnxt  call lstchk
        ret z
        ld e,a
        ld a,(prgobjlst1+12)
        inc a
        cp e
        jr c,lstnxt1
        xor a
        scf
lstnxt1 push af
        call lstakt1
        pop af
        ccf
        ret

;### LSTPRV -> Holt Pfad des vorherigen Eintrages in der Playliste
;### Ausgabe    CF=0 -> (sndfil)=File, CF=1 -> kein Eintrag vorhanden
lstprv  call lstchk
        ret z
        ld e,a
        ld a,(prgobjlst1+12)
        sub 1
        jr nc,lstakt1
        ld a,e
        dec a
        jr lstakt1

;### LSTRND -> Holt Pfad eines zuflligen Eintrages in der Playliste
;### Ausgabe    CF=0 -> (sndfil)=File, CF=1 -> kein Eintrag vorhanden
lstrnd  call lstchk
        ret z
        dec a
        jr z,lstakt1
        inc a
        ld e,a
        ld d,0
lstrnd1 push de
        ld a,r
        and 127
        call clcm16
        pop de
        sla l
        rl h
        ld a,(prgobjlst1+12)
        cp h
        jr z,lstrnd1
        ld a,h
        jr lstakt1

;### LSTAKT -> Holt Pfad des aktuellen Eintrages in der Playliste
;### Ausgabe    CF=0 -> (sndfil)=File, CF=1 -> kein Eintrag vorhanden
lstakt  call lstchk
        ret z
        ld a,(prgobjlst1+12)
lstakt1 ld (prgobjlst1+12),a
        push af
        ld l,a
        ld h,0
        add hl,hl:add hl,hl:add hl,hl       ;HL=Position in Fenster
        inc hl
        ld e,l
        ld d,h
        ld bc,(prglstdat+14)
        or a
        sbc hl,bc
        ld bc,(prglstdat+48)
        jr c,lstakt3
        push bc
        dec bc:dec bc:dec bc:dec bc:dec bc:dec bc:dec bc
        sbc hl,bc
        pop bc
        jr c,lstakt4
lstakt3 ld hl,(prglstdat+18)
        sbc hl,bc
        jr c,lstakt5
        sbc hl,de
        jr nc,lstakt6
        add hl,de
        ex de,hl
        jr lstakt6
lstakt5 ld de,0
lstakt6 ld (prglstdat+14),de
        ld c,MSC_DSK_WINSLD
        ld a,(lstwin)
        call ctlsta2
lstakt4 ld e,1
        ld c,MSC_DSK_WINDIN
        ld a,(lstwin)
        call ctlsta2
        ld hl,lstpth
        ld de,sndfil
lstakt2 ld a,(hl)
        ldi
        or a
        jr nz,lstakt2
        dec de
        pop af
        call lstakt0
        ld bc,lstmem+4
        add hl,bc
        ld bc,13
        ldir
        or a
        ret
lstakt0 ld c,a
        ld b,0
        add a
        ld l,a
        ld h,b
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,bc
        ret

;### LSTLOD -> Ldt Songliste
lstlod  ld hl,splmsk
        ld a,(prgbnknum)
        ld c,8
        ld ix,200
        ld iy,4000
        ld de,prgwindat
        call SySystem_SELOPN
        or a
        jp nz,prgprz0
        ld a,(prgbnknum)    ;File ffnen
        db #dd:ld h,a
        ld hl,splfil
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN   ;IXH,HL=Dateiangabe
        jr c,lstsav1
        push af
        ld de,(prgbnknum)   ;File laden
        ld hl,lstpth
        ld bc,lstmax+256+2
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        pop bc
        push af
        ld a,b              ;File schlieen
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        pop af
        ld a,(lstanz)
        jr nc,lstlos1
        call prgerr
        xor a
lstlos1 ld (prgobjlst1),a
        call lstupd
        jp lstsno

;### LSTSAV -> Speichert Songliste
lstsav  ld hl,splmsk
        ld a,(prgbnknum)
        set 6,a
        ld c,8
        ld ix,200
        ld iy,4000
        ld de,prgwindat
        call SySystem_SELOPN
        or a
        jp nz,prgprz0
        ld a,(prgobjlst1)
        ld (lstanz),a
        ld a,(prgbnknum)    ;File erstellen
        db #dd:ld h,a
        xor a
        ld hl,splfil
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILNEW   ;IXH,HL=Dateiangabe, A=Attribut
        jr c,lstsav1
        push af
        ld de,(prgbnknum)   ;File speichern
        ld hl,lstpth
        ld bc,lstmax+256+2
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOUT
        pop bc
        push af
        ld a,b              ;File schlieen
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        pop af
lstsav1 call c,prgerr
        jp prgprz0

;==============================================================================
;### MIXER ####################################################################
;==============================================================================

;### MIXOPN -> ffnet Mixer-Fenster
mixopn  ld a,(mixwin)
        inc a
        jp nz,prgprz0
        ld c,MSC_DSK_WINOPN
        ld a,(prgbnknum)
        ld b,a
        ld de,prgwinmix
        call msgsnd             ;Fenster aufbauen
mixopn1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        jp z,prgprz0
        cp MSR_DSK_WOPNOK
        jr nz,mixopn1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (mixwin),a           ;Fenster wurde geffnet -> Nummer merken
        jp prgprz0

;### MIXCLO -> Schliet Mixer-Fenster
mixclo  ld hl,mixwin
        ld a,(hl)
        cp -1
        jp z,prgprz0
        ld (hl),-1
        ld c,MSC_DSK_WINCLS
        ld b,a
        call msgsnd
        jp prgprz0

;### MIXSET -> Setzt erweiterte Mixer-Einstellungen
mixset0 call mixset
        jp prgprz0
mixset  ld a,(mixobjdatb+2)
        ld b,a
        ld a,(mixobjdate+2)
        ld c,a
        ld a,(mixobjdats)
        ld e,a
        ld a,(sndinip)
        jp mp3ext


;==============================================================================
;### CONTROLS #################################################################
;==============================================================================

ctltyp  db 0    ;0=Starkos, 1=SoundTrakker, 2=MP3, 3=PT3
ctltim  db 0,0
ctllen  dw 0
ctlskp  dw 0

;### CTLINC -> Spielzeit erhhen
ctlincs db 0            ;Flag, ob weiterspielen
ctlinc  ld a,(iy+1)
        inc a
        jr z,ctlinc4
        dec a
        jr z,ctlinc3
        dec a
        jp nz,prgprz0
        ld a,(ctltyp)   ;*** Timer
        cp 2
        jr z,ctlinc9
        ld ix,ctltim
        ld a,(ix+0)
        inc a
        cp 60
        jr c,ctlinc2
        ld a,(ix+1)
        inc a
        cp 99
        jr c,ctlinc1
        xor a
ctlinc1 ld (ix+1),a
        xor a
ctlinc2 ld (ix+0),a
ctlinc9 call ctltup
        jp prgprz0
ctlinc3 ld e,(iy+2)     ;*** Position
        ld d,(iy+3)
        call ctlpup
        jp prgprz0
ctlinc4 ld a,1          ;*** Ende
        ld (ctlincs),a
        ld a,(ctlshuf)
        or a
        jr z,ctlinc5
        call lstrnd
        jr c,ctlinc7        ;kein eintrag, selben sound evtl.repeaten
        jr ctlinc6
ctlinc5 call lstnxt
        jr c,ctlinc7        ;kein eintrag, selben sound evtl.repeaten
        jr nz,ctlinc6
        ld a,(ctlrepf)
        or a
        jr nz,ctlinc6
        ld (ctlincs),a      ;Ende erreicht + kein Repeat -> Stop
ctlinc6 call sndlod
        push af
        call ctlnam
        pop af
        jp c,ctlstp         ;Laden gescheitert -> Stop
        ld a,(ctlincs)
ctlinc8 or a                ;Play oder Stop, je nach Stop-Flag
        jp nz,ctlply
        jp ctlstp
ctlinc7 ld a,(ctlrepf)
        jr ctlinc8

;### CTLPUP -> Position anzeigen
;### Eingabe    DE=Position
ctlpup  ld bc,140-8
        call clcmul     ;A,HL=sngpos*sldlen
        ld c,l
        ld b,h
        ld de,(ctllen)
        call clcdiv     ;HL=sngpos*sldlen/snglen=sldpos
        ex de,hl
ctlpup1 ld hl,-1
        or a
        sbc hl,de
        ret z
        ld (ctlpup1+1),de
        ld hl,4
        add hl,de
        ld (prgwinobj2),hl
        ld de,256*10+256-2
        jp ctlsta1

;### CTLVUP -> Volume anzeigen
ctlvup  ld a,(sndiniv)
        inc a
        ld h,94-54
        jr z,ctlvup1
        dec a
        ld de,48-8
        call clcm16     ;HL=volpos*sldlen
ctlvup1 ld a,h
        add 54
        ld (prgwinobj4),a
        ld de,256*6+256-2
        jp ctlsta1

;### CTLBUP -> Panning anzeigen
ctlbup  ld a,(sndinip)
        inc a
        ld h,118-106
        jr z,ctlbup1
        dec a
        ld de,20-8
        call clcm16     ;HL=panpos*sldlen
ctlbup1 ld a,h
        add 106
        ld (prgwinobj5),a
        ld de,256*8+256-2
        jp ctlsta1

;### CTLTUP -> Spielzeit anzeigen
ctltup  ld a,(ctltim+0)
        call clcdez
        ld (prgwintxt1+4),hl
        ld a,(ctltim+1)
        call clcdez
        ld (prgwintxt1+1),hl
        ld e,1
        jr ctlsta1

;### CTLSTA -> Spielstatus updaten
;### Eingabe    HL=Grafik
ctlsta  ld (prgwinobj1),hl
        ld e,2
ctlsta1 ld c,MSC_DSK_WINDIN
        ld a,(prgwin)
ctlsta2 or a
        ret z
        ld b,a
        jp msgsnd

;### CTLNRS -> Lscht Songnamen
ctlnrs  ld hl,prgwintxt0
        ld (prgwindsc2),hl
        ret

;### CTLNAM -> Setzt Songnamen
ctlnam  ld a,(prgobjlst1+12)
        call lstakt0
        ld bc,lstmem
        add hl,bc
        ld de,lstnam
        ld (prgwindsc2),de
        ld bc,17
        ldir
        ld hl,4-17
        add hl,de
        ld a,(hl)
        call clcucs
        ld (hl),a
        ld e,3
ctlnam1 inc hl
        ld a,(hl)
        or a
        jr z,ctlsta1
        call clclcs
        ld (hl),a
        jr ctlnam1
;HL=Pfad -> HL=Name=Pfadende+2
ctlnam0 ld e,l
        ld d,h
ctlnama ld a,(hl)
        inc hl
        cp "/"
        jr z,ctlname
        cp "\"
        jr nz,ctlnamb
ctlname ld e,l
        ld d,h
ctlnamb or a
        jr nz,ctlnama
        ex de,hl        ;HL=Name
        ret

;### CTLPLY -> Sound abspielen
ctlply  ld a,(sndinif)
        or a
        jp z,lstclk1
        ld hl,gfxply
        call ctlsta
        call sndply
        jp prgprz0

;### CTLPAU -> Sound anhalten
ctlpau  ld a,(sndinif)
        or a
        jp z,prgprz0
        ld hl,(prgwinobj1)
        ld de,gfxpau
        sbc hl,de
        jr z,ctlply
        ex de,hl
        call ctlsta
        call sndpau
        jp prgprz0

;### CTLSTP -> Sound stoppen
ctlstp  call sndstp
        jp prgprz0

;### CTLSKF -> Skip forward
ctlskf  ld hl,(prgtimp)
        ld de,(ctlskp)
        add hl,de
        ex de,hl
        ld hl,(ctllen)
        dec hl
        sbc hl,de
        ex de,hl
        jr nc,ctlpos2
        add hl,de
        jr ctlpos2

;### CTLSKB -> Skip backward
ctlskb  ld hl,(prgtimp)
        ld de,(ctlskp)
        inc de
        or a
        sbc hl,de
        jr nc,ctlpos2
        ld hl,0
        jr ctlpos2

;### CTLPOS -> Position setzen
ctlpos  ld l,(iy+4)
        ld h,(iy+5)
        ld de,-4-4
        add hl,de           ;HL=Xpos auf Slider
        ld b,0
        jr c,ctlpos1
        ld l,b
ctlpos1 ld c,l
        ld de,(ctllen)
        call clcmul         ;A,HL=sldpos*snglen
        ld c,l
        ld b,h
        ld de,140-8
        call clcdiv         ;HL=sldpos*snglen/sldlen
ctlpos2 push hl
        call sndpos
        pop de
        call ctlpup
        jp prgprz0

;### CTLVLU -> Increase Volume
ctlvlu  ld a,(sndiniv)
        add 8
        jr nc,ctlvol3
        ld a,-1
        jr ctlvol3

;### CTLVLD -> Decrease Volume
ctlvld  ld a,(sndiniv)
        sub 8
        jr nc,ctlvol3
        xor a
        jr ctlvol3

;### CTLVOL -> Volume setzen
ctlvol  ld l,(iy+4)
        ld h,(iy+5)
        ld de,-54-4
        add hl,de           ;HL=Xpos auf Slider
        jr c,ctlvol1
        ld l,0
ctlvol1 ld b,l
        ld c,0
        ld de,48-8
        call clcd16         ;HL=sldpos*256/sldlen
        dec h
        jr nz,ctlvol2
        ld l,255
ctlvol2 ld a,l
ctlvol3 ld (sndiniv),a
        call sndvol
        call ctlvup
        jp prgprz0

;### CTLPAN -> Panning setzen
ctlpan  ld l,(iy+4)
        ld h,(iy+5)
        ld de,-106-4
        add hl,de           ;HL=Xpos auf Slider
        jr c,ctlpan1
        ld l,0
ctlpan1 ld b,l
        ld c,0
        ld de,20-8
        call clcd16         ;HL=sldpos*256/sldlen
        dec h
        jr nz,ctlpan2
        ld l,255
ctlpan2 ld a,l
        ld (sndinip),a
        call mixset
        call ctlbup
        jp prgprz0

;### CTLREW -> Ein Lied zurck
ctlrew  ld a,(ctlshuf)
        or a
        jr z,ctlrew1
ctlrew0 call lstrnd
        jr ctlrew2
ctlrew1 call lstprv         ;CF=0 -> (sndfil)=File, CF=1 -> kein Eintrag vorhanden
ctlrew2 jp c,prgprz0
        ld hl,(prgwinobj1)
        ld de,gfxply
        sbc hl,de
        jr z,ctlopn1
        call sndlod
        push af
        call ctlnam
        pop af
        jp ctlstp

;### CTLFFW -> Ein Lied weiter
ctlffw  ld a,(ctlshuf)
        or a
        jr nz,ctlrew0
        call lstnxt         ;CF=0 -> (sndfil)=File, ZF=1 am Anfang, CF=1 -> kein Eintrag vorhanden
        jr ctlrew2

;### CTLOPN -> neuen Sound laden
ctlopn  ld hl,sndmsk
        ld a,(prgbnknum)
        ld c,8
        ld ix,200
        ld iy,4000
        ld de,prgwindat
        call SySystem_SELOPN
        push af
        call ctlnrs
        pop af
        or a
        jp nz,prgprz0
ctlopn0 xor a
        ld (prgobjlst1),a
        ld (prgobjlst1+12),a
        ld hl,sndfil
        ld de,lstfil
        ld bc,256
        ldir
        xor a
        ld (lstafim),a
        ld l,a
        ld h,a
        ld (prglstdat+14),hl
        call lstafi0            ;Songliste lschen und Sound hinzufgen
ctlopn1 call sndlod
        push af
        call ctlnam
        pop af
        jp c,ctlstp
        jp ctlply

;### CTLREP -> Repeat an/aus
ctlrep  ld hl,ctlrepf
        ld bc,prgwinobj3+16+4
        ld ix,prgwinmen2a
        ld e,13
ctlrep1 ld a,(hl)
        xor 1
        ld (hl),a
        call ctlrep0
        call ctlsta1
        jp prgprz0
ctlrep0 ld a,(hl)
        add a
        ld d,a
        ld a,(ix+0)
        and 255-2
        or d
        ld (ix+0),a
        ld a,(hl)
        inc a
        ld (bc),a
        ret

;### CTLSHU -> Shuffle an/aus
ctlshu  ld hl,ctlshuf
        ld bc,prgwinobj3+4
        ld ix,prgwinmen2b
        ld e,12
        jr ctlrep1


;==============================================================================
;### SOUND-PLAY ###############################################################
;==============================================================================

READ "App-SymAmp-SKM.asm"
READ "App-SymAmp-ST2.asm"
READ "App-SymAmp-MP3.asm"
READ "App-SymAmp-PT3.asm"

;### SNDPAR -> Angehngten Sound suchen
sndpar  ld hl,(prgcodbeg)       ;nach angehngtem Sound suchen
        ld de,prgcodbeg
        dec h
        add hl,de               ;HL=CodeEnde=Pfad
        ld b,255
sndpar1 ld a,(hl)
        or a
        jp z,prgprz0
        cp 32
        jr z,sndpar2
        inc hl
        djnz sndpar1
        jp prgprz0
sndpar2 inc hl
        ld de,sndfil
        ld bc,256
        ldir
        jp ctlopn0

;### SNDLOD -> Ldt und initialisiert Modul
;### Eingabe    (sndfil)=File
;### Ausgabe    CF=0 ok, CF=1 Fehler, A=Typ (1=Fehler beim Laden, 2=nicht untersttztes Format, 3=Modul zu gro)
sndlodskm   db "SK10"
sndlodst2   db "ST-128"
sndlodmp3   db "MP3"
sndlodpt3   db "PT3"

sndlodlen   dw 0    ;lnge der geladenen datei
sndlodt     db 0    ;typ bereits durch endung bekannt

sndlod  xor a
        ld (sndlodt),a
        call sndpau         ;alten Sound stoppen
        call sndres
        call mp3del
        call sndlod0
        ld (prgwintxt3),hl
        ld (prgwintxt4),hl
        ld de,0             ;test, ob *.mp3
        ld hl,sndfil
        ld b,255
sndlod6 ld a,(hl)
        inc hl
        or a
        jr z,sndlod8
        cp "."
        jr nz,sndlod7
        ld e,l
        ld d,h
sndlod7 djnz sndlod6
sndlod8 ld a,e
        or d
        jr z,sndloda
        ex de,hl
        push hl
        ld de,sndlodmp3
        ld b,3
        call strcmp
        pop hl
        jr nz,sndlodb
        ld hl,sndfil
        ld de,sndmem
        ld bc,256
        ldir
        ld a,2
        jp sndlod3
sndlodb ld de,sndlodpt3     ;test, ob *.pt3
        ld b,3
        call strcmp
        jr nz,sndloda
        ld a,3
        ld (sndlodt),a
sndloda ld a,(prgbnknum)    ;File ffnen
        db #dd:ld h,a
        ld hl,sndfil
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILOPN
        jp c,sndlod1
        push af
        ld de,(prgbnknum)   ;File laden
        ld hl,sndmem
        ld bc,sndmax
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILINP
        ld (sndlodlen),bc
        pop bc
        push af
        ld a,b              ;File schlieen
        call syscll
        db MSC_SYS_SYSFIL
        db FNC_FIL_FILCLO
        pop af
        jr c,sndlod1
        ld a,3              ;Lnge berprfen
        scf
        jr z,sndlod1
        ld a,(sndlodt)
        or a
        jr nz,sndlod3
        ld hl,sndmem        ;Format erkennen
        ld bc,128
        add hl,bc
        ld de,sndlodskm
        ld b,4
        call strcmp
        jr z,sndlod3
        ld hl,sndmem
        ld bc,#498+128
        add hl,bc
        ld de,sndlodst2
        ld b,6
        call strcmp
        ld a,1
        jr z,sndlod3
        scf                 ;unbekanntes Format
        jr sndlod4
sndlod3 call sndini         ;Sound initialisieren
        ld a,0
        ret nc
sndlod4 ld a,2              ;Fehler -> nicht untersttztes Format
        jp sndres
sndlod1 ld a,1              ;Fehler -> Laden gescheitert
        jp sndres
sndlod0 ld hl,45
        ld (propertxt3b),hl
        ld (propertxt4b),hl
        ld (propertxt5b),hl
        ld (propertxt6b),hl
        ld (propertxt7b),hl
        ret

;### SNDINI -> Initialisiert geladenes Modul eines bestimmten Types
;### Eingabe    A=Typ (0=Starkos, 1=SoundTrakker, 2=MP3, 3=PT3)
;### Ausgabe    CF=1 nicht untersttztes Format
sndjmp  dw sksini,sksply,sksstp,skspos,sksvol,skschn
        dw st2ini,st2ply,st2stp,st2pos,st2vol,st2chn
        dw mp3ini,mp3ply,mp3stp,mp3pos,mp3vol,mp3chn
        dw pt3ini,pt3ply,pt3stp,pt3pos,pt3vol,pt3chn
sndinif dw 0        ;Flag, ob gltiger Sound geladen wurde
sndiniv db 255      ;Volume (0-255)
sndinip db 128      ;panning

sndini  ld (ctltyp),a
        add a
        add a
        ld c,a
        add a
        add c
        ld c,a
        ld b,0
        ld ix,sndjmp
        add ix,bc
        ld l,(ix+0)
        ld h,(ix+1)
        ld (sndstp1+1),hl   ;Init Routine setzen
        ld l,(ix+2)
        ld h,(ix+3)
        ld (prgtim1+1),hl   ;Play Routine setzen
        ld l,(ix+4)
        ld h,(ix+5)
        ld (sndpau1+1),hl   ;Mute Routine setzen
        ld l,(ix+6)
        ld h,(ix+7)
        ld (sndpos1+1),hl   ;Pos  Routine setzen
        ld l,(ix+8)
        ld h,(ix+9)
        ld (sndvol +1),hl   ;Vol  Routine setzen
        ld l,(ix+10)
        ld h,(ix+11)
        ld (sndchn +1),hl   ;Chn  Routine setzen
        ld hl,1
        ld (ctlskp),hl
        ld a,l
        ld (sndinif),a
        call sndstp0        ;Song initialisieren
        ld (ctllen),hl      ;Lnge merken
        jr c,sndres
        ld de,256*4+256-2
        call ctlsta1        ;KHz und Kbps updaten
        or a
        ret

;### SNDRES -> Deaktiviert die Soundausgabe
sndres  ld hl,sndres0       ;Routinen deaktivieren
        ld (sndstp1+1),hl
        ld (prgtim1+1),hl
        ld (sndpau1+1),hl
        ld (sndpos1+1),hl
        ld (sndvol +1),hl
        ld hl,-1
        ld (prgtimp),hl
        inc hl
        ld (sndinif),hl
sndres0 ret

;### SNDPLY -> Startet Abspielen
sndply  db #3e:scf
        ld (prgtim),a
        ret

;### SNDPAU -> Hlt Abspielen an
sndpau  db #3e:or a
        ld (prgtim),a
sndpau1 jp sndres0          ;### MUTE

;### SNDSTP -> Stoppt Song und setzt Position an den Anfang
;### Ausgabe    CF=1 nicht untersttztes Format
sndstp  ld hl,gfxstp
        call ctlsta
        call sndpau
sndstp0 ld a,50
        ld (prgtimc),a
        ld hl,-1
        ld (prgtimp),hl
        inc hl
        ld (ctltim),hl
        ex de,hl
        call ctlpup
        call ctltup
        call anaoff
sndstp2 ld a,(sndiniv)
        call sndvol
        ld hl,sndmem
        ld de,128
        add hl,de
sndstp1 call sndres0        ;### INIT
        ret c
        ld (anaupd8-1),a
        ld a,(diawin)
        inc a
        ret z
        dec a
        push hl
        push af
        ld hl,sndfil
        ld de,propertxt10
        call prpinf3
        ld a,19
        call prpinf
        pop bc
        ld c,MSC_DSK_WINDIN
        ld e,-1
        call msgsnd
        pop hl
        or a
        ret

;### SNDPOS -> Setzt Song-Position
;### Eingabe    HL=neue Position
sndpos  push hl
        call sndpau
        call sndstp2
        pop hl
sndpos1 call sndres0        ;### POS
        jr sndply

;### SNDVOL -> Setzt Song-Volume
;### Eingabe    A=neue Volume (0-255)
sndvol  jp sndres0          ;### VOLUME

;### SNDCHN -> Holt Frequenz und Volume
;### Eingabe    A=Kanal (0-x)
;### Ausgabe    A=Volume (0-15), L=Frequenz (0-15)
sndchn  jp sndres0          ;### CHN

;### PRGTIM -> Programm-Timer, spielt Sound ab
prgtima db 4
prgtimc db 50
prgtimp dw 0
prgtim  or a
        jr nc,prgtim0
        or a
        ld hl,0
prgtim1 call sndres0        ;### PLAY
        jr nc,prgtim4
        push hl
        ld c,-1             ;Sound hat Ende erreicht
        call prgtim2
        pop hl
prgtim4 ex de,hl
        ld hl,(prgtimp)
        ld (prgtimp),de
        or a
        sbc hl,de
        jr z,prgtim3
        ld c,0              ;Position gendert
        call prgtim2
prgtim3 ld a,(anaflg)
        or a
        jr z,prgtim5
        ld hl,prgtima
        dec (hl)
        jr nz,prgtim5
        ld (hl),4
        call anaplt         ;Analizer updaten
prgtim5 ld hl,prgtimc
        dec (hl)
        jr nz,prgtim0
        ld a,(ctltyp)
        cp 2
        ld a,-1
        jr z,prgtim6
        ld a,50
prgtim6 ld (hl),a
        ld c,1              ;eine Sekunde bzw. Verzgerung abgelaufen
        call prgtim2
prgtim0 rst #30
        jr prgtim
prgtim2 ld a,(prgtimn)      ;Message an Hauptprozess senden
        db #dd:ld l,a
        ld a,(prgprzn)
        db #dd:ld h,a
        ld iy,timmsgb
        ld (iy+0),1
        ld (iy+1),c         ;0=Pos, 1=Sekunde, -1=Ende
        ld (iy+2),e         ;aktuelle Pos eintragen
        ld (iy+3),d
        rst #10
        ret


;==============================================================================
;### DIALOG-ROUTINEN ##########################################################
;==============================================================================

diaopn  ld c,MSC_DSK_WINOPN     ;Fenster aufbauen
        ld a,(prgbnknum)
        ld b,a
        call msgsnd
diaopn1 call msgdsk             ;Message holen -> IXL=Status, IXH=Absender-Proze
        cp MSR_DSK_WOPNER
        ret z                   ;kein Speicher fr Fenster -> dann halt nicht
        cp MSR_DSK_WOPNOK
        jr nz,diaopn1           ;andere Message als "Fenster geffnet" -> ignorieren
        ld a,(prgmsgb+4)
        ld (diawin),a           ;Fenster wurde geffnet -> Nummer merken
        inc a
        ld (prgwindat+windatsup),a
        jp prgprz0

diacnc  call diaclo             ;*** CANCEL
        jp prgprz0

diaclo  ld c,MSC_DSK_WINCLS     ;Dialog-Fenster schliessen
        ld hl,diawin
        ld a,(hl)
        ld (hl),-1
        ld b,a
        jp msgsnd


;==============================================================================
;### SUB-ROUTINEN #############################################################
;==============================================================================

SySystem_HLPFLG db 0    ;flag, if HLP-path is valid
SySystem_HLPPTH db "%help.exe "
SySystem_HLPPTH1 ds 128
SySHInX db ".HLP",0

SySystem_HLPINI
        ld hl,(prgcodbeg)
        ld de,prgcodbeg
        dec h
        add hl,de                   ;HL = CodeEnd = Command line
        ld de,SySystem_HLPPTH1
        ld bc,0
        db #dd:ld l,128
SySHIn1 ld a,(hl)
        or a
        jr z,SySHIn3
        cp " "
        jr z,SySHIn3
        cp "."
        jr nz,SySHIn2
        ld c,e
        ld b,d
SySHIn2 ld (de),a
        inc hl
        inc de
        db #dd:dec l
        ret z
        jr SySHIn1
SySHIn3 ld a,c
        or b
        ret z
        ld e,c
        ld d,b
        ld hl,SySHInX
        ld bc,5
        ldir
        ld a,1
        ld (SySystem_HLPFLG),a
        ret

hlpopn  ld a,(SySystem_HLPFLG)
        or a
        jp z,prgprz0
        ld a,(prgbnknum)
        ld d,a
        ld a,PRC_ID_SYSTEM
        ld c,MSC_SYS_PRGRUN
        ld hl,SySystem_HLPPTH
        ld b,l
        ld e,h
        call msgsnd1
        jp prgprz0


;### SYSINI -> Computer-Typ abhngige Initialisierung
sysini  ld hl,jmp_sysinf        ;*** Computer-Typ holen
        ld de,256*1+5
        ld ix,cfgcpctyp
        ld iy,66+2+6+8
        rst #28
        ld a,(cfgcpctyp)
        and 15
        cp 8
        push af
        ld hl,skmcpc
        jr c,sysini1
        ld hl,0
        ld (sendreg),hl
        ld (st2reg),hl
        ;ld (ROUT_A0),hl    ##!!##
        ld hl,skmmsx
sysini1 ld (skmreg0+1),hl
        ld (skmreg1+1),hl
        ld (skmreg2+1),hl
        ld (skmreg3+1),hl
        ld (skmreg4+1),hl
        ld (skmreg5+1),hl
        ld (skmreg6+1),hl
        ld (skmreg7+1),hl
        ld (skmreg8+1),hl
        ld (skmreg9+1),hl
        ld (skmrega+1),hl
        ld (skmregb+1),hl
        ld (skmregc+1),hl
        ld (skmregd+1),hl
        ld hl,jmp_scrget
        rst #28
        ld bc,-149
        add ix,bc
        ld (prgwindat+4),ix
        ld (prglstdat+4),ix
        ld bc,-96
        add iy,bc
        ld (prgwindat+6),iy
        ld bc,96-124
        add iy,bc
        ld (prglstdat+10),iy
        pop af
        ld a,1
        adc 0       ;1=msx, 2=cpc
        call mp3drv
        ret nc
        xor a
        jp mp3drv

;### CFGINI -> Config bernehmen
cfgini  ld hl,ctlrepf
        ld bc,prgwinobj3+16+4
        ld ix,prgwinmen2a
        call ctlrep0
        ld hl,ctlshuf
        ld bc,prgwinobj3+4
        ld ix,prgwinmen2b
        jp ctlrep0

;### SPRCNV -> Konvertiert Sprite vom CPC ins MSX Format
;### Eingabe    IX=Sprite (inklusive Header)
;### Veraendert BC
sprcnv  set 7,(hl)
        ld de,10*12
        inc hl:inc hl
sprcnv1 inc hl
        ld c,(hl)
        xor a:rl c:rla
        add a:rl c:rla
        add a:rl c:rla
        add a:rl c:rla
        ld b,a
        rl c:rla:add a
        rl c:rla:add a
        rl c:rla:add a
        rl c:rla:add a
        or b
        ld (hl),a
        dec de
        ld a,e
        or d
        jr nz,sprcnv1
        ret

;### GFXINI -> Sprites aus "Skin" kopieren
gfxini  ld hl,gfxbgr3+2
        ld de,gfxana0+3
        ld a,12
gfxini1 ld bc,10
        ldir
        ld bc,37-10
        add hl,bc
        dec a
        jr nz,gfxini1
        ld hl,gfxana0+3
        ld de,gfxana1+3
        ld bc,10*12
        ldir
        ld a,(cfgcpctyp)
        and 15
        cp 8
        jr c,gfxini2
        ld hl,gfxana0
        call sprcnv
        ld hl,gfxana2
        call sprcnv
gfxini2 ld hl,gfxbgr1+2
        ld de,gfxply+3
        ld a,8
        call gfxini0
        ld hl,gfxbgr1+4
        ld de,gfxpau+3
        ld a,8
        call gfxini0
        ld hl,gfxbgr1+6
        ld de,gfxstp+3
        ld a,8
        call gfxini0
        ld hl,gfxbgr2+1
        ld de,gfxsld+3
        ld a,6
gfxini0 ldi
        ldi
        ld bc,37-2
        add hl,bc
        dec a
        jr nz,gfxini0
        ret

;### MSGGET -> Message fr Programm abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgget  db #dd:ld h,-1
msgget1 ld a,(prgprzn)
        db #dd:ld l,a           ;IXL=Rechner-Proze-Nummer
        ld iy,prgmsgb           ;IY=Messagebuffer
        rst #08                 ;Message holen -> IXL=Status, IXH=Absender-Proze
        or a
        db #dd:dec l
        ret nz
        ld iy,prgmsgb
        ld a,(iy+0)
        or a
        jp z,prgend
        scf
        ret

;### MSGDSK -> Message fr Programm von Desktop-Prozess abholen
;### Ausgabe    CF=0 -> keine Message vorhanden, CF=1 -> IXH=Absender, (recmsgb)=Message, A=(recmsgb+0), IY=recmsgb
;### Veraendert 
msgdsk  call msgget
        jr nc,msgdsk            ;keine Message
        ld a,(dskprzn)
        db #dd:cp h
        jr nz,msgdsk            ;Message von anderem als Desktop-Proze -> ignorieren
        ld a,(prgmsgb)
        ret

;### MSGSND -> Message an Desktop-Prozess senden
;### Eingabe    C=Kommando, B/E/D/L/H=Parameter1/2/3/4/5
msgsnd  ld a,(dskprzn)
msgsnd1 db #dd:ld h,a
        ld a,(prgprzn)
        db #dd:ld l,a
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),b
        ld (iy+2),e
        ld (iy+3),d
        ld (iy+4),l
        ld (iy+5),h
        rst #10
        ret

;### SYSCLL -> Betriebssystem-Funktion aufrufen
;### Eingabe    (SP)=Modul/Funktion, AF,BC,DE,HL,IX,IY=Register
;### Ausgabe    AF,BC,DE,HL,IX,IY=Register
sysclln db 0
syscll  ld (prgmsgb+04),bc      ;Register in Message-Buffer kopieren
        ld (prgmsgb+06),de
        ld (prgmsgb+08),hl
        ld (prgmsgb+10),ix
        ld (prgmsgb+12),iy
        push af
        pop hl
        ld (prgmsgb+02),hl
        pop hl
        ld e,(hl)
        inc hl
        ld d,(hl)
        inc hl
        push hl
        ld (prgmsgb+00),de      ;Modul und Funktion in Message-Buffer kopieren
        ld a,e
        ld (sysclln),a
        ld iy,prgmsgb
        ld a,(prgprzn)          ;Desktop und System-Prozessnummer holen
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #10                 ;Message senden
syscll1 rst #30
        ld iy,prgmsgb
        ld a,(prgprzn)
        db #dd:ld l,a
        ld a,(sysprzn)
        db #dd:ld h,a
        rst #18                 ;auf Antwort warten
        db #dd:dec l
        jr nz,syscll1
        ld a,(prgmsgb)
        sub 128
        ld e,a
        ld a,(sysclln)
        cp e
        jr nz,syscll1
        ld hl,(prgmsgb+02)      ;Register aus Message-Buffer holen
        push hl
        pop af
        ld bc,(prgmsgb+04)
        ld de,(prgmsgb+06)
        ld hl,(prgmsgb+08)
        ld ix,(prgmsgb+10)
        ld iy,(prgmsgb+12)
        ret

;### CLCMUL -> Multipliziert zwei Werte (24bit)
;### Eingabe    BC=Wert1, DE=Wert2
;### Ausgabe    A,HL=Wert1*Wert2 (24bit)
;### Veraendert F,BC,DE,IX
clcmul  ld ix,0
        ld hl,0
clcmul1 ld a,c
        or b
        jr z,clcmul3
        srl b
        rr c
        jr nc,clcmul2
        add ix,de
        ld a,h
        adc l
        ld h,a
clcmul2 sla e
        rl d
        rl l
        jr clcmul1
clcmul3 ld a,h
        db #dd:ld e,l
        db #dd:ld d,h
        ex de,hl
        ret

;### CLCDIV -> Dividiert zwei Werte (24bit)
;### Eingabe    A,BC=Wert1, DE=Wert2
;### Ausgabe    HL=Wert1/Wert2, DE=Wert1 MOD Wert2
;### Veraendert AF,BC,DE,IX,IYL
clcdiv  db #dd:ld l,e
        db #dd:ld h,d   ;IX=Wert2(Nenner)
        ld e,a          ;E,BC=Wert1(Zaehler)
        ld hl,0
        db #dd:ld a,l
        or d
        ret z
        ld d,l          ;D,HL=RechenVar
        db #fd:ld l,24  ;IYL=Counter
clcdiv1 rl c
        rl b
        rl e
        adc hl,hl
        rl d
        ld a,l
        db #dd:sub l
        ld l,a
        ld a,h
        db #dd:sbc h
        ld h,a
        ld a,d
        sbc 0
        ld d,a          ;D,HL=D,HL-IX
        jr nc,clcdiv2
        ld a,l
        db #dd:add l
        ld l,a
        ld a,h
        db #dd:adc h
        ld h,a
        ld a,d
        adc 0
        ld d,a
        scf
clcdiv2 db #fd:dec l
        jr nz,clcdiv1
        ex de,hl        ;DE=Wert1 MOD Wert2
        ld a,c
        rla
        cpl
        ld l,a
        ld a,b
        rla
        cpl
        ld h,a          ;HL=Wert1 DIV Wert2
        ret

;### CLCD32 -> Dividiert zwei Werte (32bit)
;### Eingabe    IY,BC=Wert1, IX=Wert2
;### Ausgabe    IY,BC=Wert1/Wert2, HL=Wert1 MOD Wert2
;### Veraendert AF,BC,DE,IY
clcd32c db 0
clcd32  ld hl,0
        db #dd:ld a,l
        db #dd:or h
        ret z           ;IY,BC=Wert1(Zaehler)
        ld de,0         ;DE,HL=RechenVar
        ld a,32         ;Counter auf 32 setzen
clcd321 ld (clcd32c),a
        rl c
        rl b
        db #fd:ld a,l:rla:db #fd:ld l,a
        db #fd:ld a,h:rla:db #fd:ld h,a
        adc hl,hl
        rl e
        rl d
        ld a,l
        db #dd:sub l
        ld l,a
        ld a,h
        db #dd:sbc h
        ld h,a
        ld a,e
        sbc 0
        ld e,a
        ld a,d
        sbc 0
        ld d,a
        jr nc,clcd322
        ld a,l
        db #dd:add l
        ld l,a
        ld a,h
        db #dd:adc h
        ld h,a
        ld a,e
        adc 0
        ld e,a
        ld a,d
        adc 0
        ld d,a
        scf
clcd322 ccf
        ld a,(clcd32c)
        dec a
        jr nz,clcd321   ;HL=Wert1 MOD Wert2
        rl c
        rl b
        db #fd:ld a,l:rla:db #fd:ld l,a
        db #fd:ld a,h:rla:db #fd:ld h,a
        ret             ;IY,BC=Wert1 DIV Wert2

;### CLCM16 -> Multipliziert zwei Werte (16bit)
;### Eingabe    A=Wert1, DE=Wert2
;### Ausgabe    HL=Wert1*Wert2 (16bit)
;### Veraendert AF,DE
clcm16  ld hl,0
        or a
clcm161 rra
        jr nc,clcm162
        add hl,de
clcm162 sla e
        rl d
        or a
        jr nz,clcm161
        ret

;### CLCD16 -> Dividiert zwei Werte (16bit)
;### Eingabe    BC=Wert1, DE=Wert2
;### Ausgabe    HL=Wert1/Wert2, DE=Wert1 MOD Wert2
;### Veraendert AF,BC,DE
clcd16  ld a,e
        or d
        ld hl,0
        ret z
        ld a,b
        ld b,16
clcd161 rl c
        rla
        rl l
        rl h
        sbc hl,de
        jr nc,clcd162
        add hl,de
clcd162 ccf
        djnz clcd161
        ex de,hl
        rl c
        rla
        ld h,a
        ld l,c
        ret

;### STRLEN -> Ermittelt Lnge eines Strings
;### Eingabe    HL=String
;### Ausgabe    HL=Stringende (0), BC=Lnge (maximal 255)
;### Verndert  -
strlen  push af
        xor a
        ld bc,255
        cpir
        ld a,254
        sub c
        ld c,a
        dec hl
        pop af
        ret

;### STRCMP -> Vergleicht zwei Strings
;### Eingabe    HL=Quell-String, DE=Vergleichstring, B=Lnge
;### Ausgabe    UCASE(HL)=(DE) -> ZF=1, A=0
;### Verndert  B,DE,HL
strcmp  ex de,hl
strcmp1 ld a,(de)
        call clcucs
        cp (hl)
        ret nz
        inc hl
        inc de
        djnz strcmp1
        xor a
        ret

;### CLCDZ3 -> Rechnet Word in drei Dezimalziffern um
;### Eingabe    HL=Wert
;### Ausgabe    A=100er-Ascii-Ziffer, L=10er-Ascii-Ziffer, H=1er-Ascii-Ziffer
;### Veraendert F,C,DE
clcdz3  ld de,100
        ld c,"0"-1
        or a
clcdz31 inc c
        sbc hl,de
        jr nc,clcdz31
        ld a,l
        add e
        call clcdez
        ld a,c
        ret

;### CLCDEZ -> Rechnet Byte in zwei Dezimalziffern um
;### Eingabe    A=Wert
;### Ausgabe    L=10er-Ascii-Ziffer, H=1er-Ascii-Ziffer
;### Veraendert AF
clcdez  ld l,0
clcdez1 sub 10
        jr c,clcdez2
        inc l
        jr clcdez1
clcdez2 add "0"+10
        ld h,a
        ld a,"0"
        add l
        ld l,a
        ret

;### CLCUCS -> Wandelt Klein- in Grobuchstaben um
;### Eingabe    A=Zeichen
;### Ausgabe    A=ucase(Zeichen)
;### Verndert  F
clcucs  cp "a"
        ret c
        cp "z"+1
        ret nc
        add "A"-"a"
        ret

;### CLCLCS -> Wandelt Gro- in Kleinbuchstaben um
;### Eingabe    A=Zeichen
;### Ausgabe    A=lcase(Zeichen)
;### Verndert  F
clclcs  cp "A"
        ret c
        cp "Z"+1
        ret nc
        add "a"-"A"
        ret


;==============================================================================
;### LIBRARY-ROUTINEN #########################################################
;==============================================================================

SyKernel_MTADDT
        ld c,MSC_KRL_MTADDT
        call SyKernel_Message
        xor a
        cp l
        ld a,h
        ret

SyKernel_Message
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),e
        ld (iy+4),a
        ld (iy+5),b
        ld a,c
        add 128
        ld (SyKMsgN),a
        db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #10
SyKMsg1 db #dd:ld h,1       ;1 is the number of the kernel process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #08             ;wait for a kernel message
        db #dd:dec l
        jr nz,SyKMsg1
        ld a,(SyKMsgN)
        cp (iy+0)
        jr nz,SyKMsg1
        ld l,(iy+1)
        ld h,(iy+2)
        ret
SyKMsgN db 0

SySystem_SELOPN
        ld (SySSOpW),de
        push iy
        ld iy,prgmsgb
        ld (iy+6),a
        ld (iy+7),c
        ld (iy+8),l
        ld (iy+9),h
        db #dd:ld a,l
        ld (iy+10),a
        db #dd:ld a,h
        ld (iy+11),a
        pop de
        ld (iy+12),e
        ld (iy+13),d
        ld c,MSC_SYS_SELOPN
        call SySystem_SendMessage
SySSOp1 call SySystem_WaitMessage
        cp MSR_SYS_SELOPN
        jr nz,SySSOp1
        ld a,(iy+1)
        cp -1
        ret nz
        ld ix,(SySSOpW)
        ld a,(iy+2)
        ld (ix+51),a
        ld ix,prglstdat
        ld a,(iy+2)
        ld (ix+51),a
        jr SySSOp1
SySSOpW dw 0

SySystem_SendMessage
        ld iy,prgmsgb
        ld (iy+0),c
        ld (iy+1),l
        ld (iy+2),h
        ld (iy+3),a
        ld (iy+4),e
        ld (iy+5),d
        db #dd:ld h,3       ;3 is the number of the system manager process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #10
        ret

SySystem_WaitMessage
        ld iy,prgmsgb
SySWMs1 db #dd:ld h,-1      ;3 is the number of the system manager process
        ld a,(prgprzn)
        db #dd:ld l,a
        rst #08             ;wait for a system manager message
        db #dd:dec l
        jr nz,SySWMs1
        ld a,(iy+0)
        ret


;### Song-Speicher
sndmax  equ 17000
sndmem  db 0                ;##!! LETZTER LABEL !!##

;==============================================================================
;### DATEN-TEIL ###############################################################
;==============================================================================

prgdatbeg

prgicn16c db 12,24,24:dw $+7:dw $+4,12*24:db 5
db #88,#88,#88,#88,#88,#8D,#D8,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#D1,#1D,#88,#88,#88,#88,#88,#88,#88,#88,#88,#8D,#17,#D1,#D8,#88,#D1,#18,#88,#88,#88,#88,#88,#D1,#D7,#77,#1D,#61,#12,#18,#88
db #88,#88,#88,#8D,#1D,#77,#77,#D1,#12,#C2,#18,#88,#88,#88,#88,#D1,#77,#77,#7D,#12,#22,#23,#98,#88,#88,#88,#8D,#1D,#77,#7D,#13,#20,#22,#95,#88,#88,#88,#88,#D1,#D7,#77,#D1,#2C,#02,#C3,#1D,#88,#88
db #88,#8D,#1D,#77,#D1,#22,#C2,#22,#3D,#D1,#D8,#88,#88,#D1,#D7,#D1,#32,#C2,#22,#C2,#1D,#7D,#1D,#88,#8D,#1D,#7D,#12,#C2,#20,#C2,#22,#21,#77,#D1,#D8,#D1,#D7,#77,#2C,#22,#E0,#22,#22,#C3,#77,#7D,#1D
db #D1,#77,#7D,#22,#2C,#02,#22,#2C,#21,#D7,#77,#1D,#8D,#17,#71,#93,#DC,#22,#22,#C2,#39,#77,#71,#D8,#88,#D1,#77,#19,#22,#22,#2C,#31,#D7,#77,#11,#88,#88,#8D,#1D,#D2,#22,#2C,#23,#97,#77,#71,#18,#88
db #88,#88,#11,#22,#2C,#23,#1D,#77,#77,#1D,#88,#88,#88,#8D,#12,#2C,#22,#9D,#77,#77,#51,#18,#88,#88,#88,#D1,#22,#C2,#31,#D7,#77,#77,#1D,#88,#88,#88,#88,#12,#2C,#21,#17,#77,#77,#71,#18,#88,#88,#88
db #88,#12,#C3,#1D,#D1,#77,#77,#11,#88,#88,#88,#88,#88,#12,#1D,#88,#81,#17,#71,#D8,#88,#88,#88,#88,#88,#91,#D8,#88,#88,#D1,#11,#88,#88,#88,#88,#88,#88,#88,#88,#88,#88,#8D,#18,#88,#88,#88,#88,#88

;### Verschiedenes
prgmsginf1 db "SymAmp",0    ;build 20141028
prgmsginf2 db "v2.3 by Prodatron/SymbiosiS,",0
prgmsginf3 db "Targhan, S.Bulba, DD&Yobi, SyX",0

prgwintit   db "SymAmp",0
prglsttit   db "Playlist Editor",0
propertit   db "File info box",0
prgtitmix   db "Sound settings",0

prgtxtok    db "Ok",0
prgtxtcnc   db "Cancel",0
prgtxtyes   db "Yes",0
prgtxtno    db "No",0

;### Menues
prgwinmentx1 db "File",0
prgwinmen1tx1 db "Play file...",0
prgwinmen1tx2 db "View file info",0
prgwinmen1tx3 db "Open playlist",0
prgwinmen1tx4 db "Save playlist",0
prgwinmen1tx5 db "Exit",0

prgwinmentx2 db "Play",0
prgwinmen2tx1 db "Previous",0
prgwinmen2tx2 db "Play",0
prgwinmen2tx3 db "Pause",0
prgwinmen2tx4 db "Stop",0
prgwinmen2tx5 db "Next",0
prgwinmen2tx6 db "Repeat",0
prgwinmen2tx7 db "Shuffle",0

prgwinmentx3 db "Options",0
prgwinmen3tx1 db "Sound settings",0
prgwinmen3tx2 db "Preferences",0

prgwinmentx4 db "View",0
prgwinmen4tx1 db "Playlist",0

prgwinmentx5 db "?",0
prgwinmen5tx1 db "Help topics",0
prgwinmen5tx2 db "About SymAmp...",0

prglstmentx1    db "+Add",0
prglstmentx2    db "-Rem",0
prglstmentx3    db "=Sel",0
prglstmentx4    db "*Misc",0
prglstmentx5    db "Up",0
prglstmentx6    db "Down",0
prglstmen1tx1   db "Add file...",0
prglstmen1tx2   db "Add folder...",0
prglstmen2tx1   db "Remove selected",0
prglstmen2tx2   db "Remove all",0
prglstmen3tx1   db "Select all",0
prglstmen3tx2   db "Select none",0
prglstmen3tx3   db "Invert selection",0
prglstmen4tx1   db "File info",0
prglstmen4tx2   db "Sort",0

prgwintxt1  db " 00:00  "
prgwintxt0  db 0
prgwintxt3  db "-",0,0,0    ;kbps
prgwintxt4  db "-",0,0      ;khz

propertxt1a db "File",0
propertxt2a db "Type",0
propertxt3a db "Title",0
propertxt4a db "Artist",0
propertxt5a db "Album",0
propertxt6a db "Year",0
propertxt7a db "Comment",0

mp3id3v1    ds 3
propertxt3b ds 31       ;Title
propertxt4b ds 31       ;Artist
propertxt5b ds 31       ;Album
propertxt6b ds 5        ;Year
propertxt7b ds 29       ;Comment
mp3id3v1dat db 0,0,0    ;?,track,genre

propertxt10 ds 256+1
propertxt2x db "Unknown"
propertxt2y db 0
propertxt20 db "Starkos 1.0/1.1 Song",0
propertxt21 db "SoundTrakker 128 Song",0
propertxt22 db "MPEG-#.# layer #, ###kbps",0
propertxt23 db "###:##, ##khz, ############",0
propertxt24 db "Pro/VortexTracker Song",0

mixobjtxt1 db "Equalizer",0
mixobjtxt2 db "Sound mode",0
mixobjtxta db "Bass",0
mixobjtxtd db "Treble",0
mixobjtxtj db "Mono",0
mixobjtxtk db "Stereo",0
mixobjtxtl db "Pseudo Stereo",0
mixobjtxtm db "Spatial Stereo",0

sysmsglod1  db "A disc error occured.",0
sysmsglod2  db "(Error code "
sysmsglod2a db "##)",0

;### Grafiken
gfxply  db 2,8,8:ds 2*8
gfxpau  db 2,8,8:ds 2*8
gfxstp  db 2,8,8:ds 2*8
gfxsld  db 2,8,6:ds 2*6
gfxana0 db 10,40,12:ds 10*12    ;leere   Grafik
gfxana1 db 10,40,12:ds 10*12    ;fertige Grafik
gfxana2 db 10,40,12             ;volle   Grafik
        ds 10,#00:ds 10,#00:ds 10,#00:ds 10,#00:ds 10,#00:ds 10,#00:ds 10,#0F:ds 10,#00:ds 10,#0F:ds 10,#FF:ds 10,#0F:ds 10,#FF

gfxbgr  db 37,148,62
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#CF,#3F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
gfxbgr1
db #0F,#F8,#30,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#10,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#00,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#E0,#0F
db #0F,#F8,#00,#70,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F
db #0F,#F8,#00,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#10,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#30,#F0,#20,#70,#00,#70,#F0,#F0,#F0,#F0,#83,#3F,#FF,#FF,#FF,#FF,#FF,#0F,#0F,#0F,#0F,#0F,#0F,#3F,#FF,#FF,#FF,#FF,#FF,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#0F,#0F,#0F,#0F,#0F,#0F,#3E,#F0,#F0,#F0,#F0,#E0,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#5A,#0F,#0F,#3C,#87,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#1E,#2D,#0F,#0F,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#96,#0F,#0F,#4B,#0F,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#1E,#2D,#0F,#0F,#0F
gfxbgr3
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#3C,#1E,#C3,#E1,#3C,#0F,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#5A,#E1,#F0,#0F,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#96,#2D,#96,#0F,#87,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#96,#2D,#2D,#0F,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#5A,#2D,#96,#4B,#87,#3E,#F0,#F0,#F0,#F0,#E0,#3C,#96,#2D,#4B,#0F,#0F
db #0F,#F8,#F3,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F8,#83,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#5A,#C3,#E1,#3C,#0F,#3E,#F0,#F0,#F0,#F0,#E0,#2D,#5A,#2D,#F0,#0F,#0F
db #0F,#F8,#F4,#F0,#F0,#F0,#F4,#F0,#F0,#F8,#F0,#F0,#83,#3E,#F0,#F0,#F0,#F0,#E0,#0F,#0F,#0F,#87,#0F,#0F,#3E,#F0,#F0,#F0,#F0,#E0,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#F3,#F9,#F4,#FA,#F6,#F4,#F9,#F2,#F7,#F8,#83,#0C,#00,#00,#00,#00,#00,#0F,#0F,#0F,#0F,#0F,#0F,#0C,#00,#00,#00,#00,#00,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#F0,#F4,#F9,#F5,#F5,#F5,#F4,#FA,#F8,#F0,#83,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#F8,#F7,#F8,#F9,#F1,#F6,#F4,#F9,#F2,#F7,#F0,#83,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#3F,#FF,#FF,#FF,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F8,#83,#3C,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C3,#3C,#F0,#F0,#F0,#F0,#C3,#2E,#00,#00,#10,#0F
db #0F,#F8,#F7,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#F0,#83,#3D,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8B,#3D,#FF,#FF,#FF,#FF,#8B,#2E,#70,#20,#10,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3D,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8B,#3D,#FF,#FF,#FF,#FF,#8B,#2E,#40,#A0,#10,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3D,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8B,#3D,#FF,#FF,#FF,#FF,#8B,#2E,#70,#20,#10,#0F
db #0F,#F8,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#83,#3D,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#8B,#3D,#FF,#FF,#FF,#FF,#8B,#2E,#40,#30,#90,#0F
db #0F,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#0C,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#03,#0C,#00,#00,#00,#00,#03,#2E,#00,#00,#10,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#3C,#F0,#F0,#F0,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
gfxbgr2
db #0F,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#0F
db #0F,#80,#10,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#EE,#0F
db #0F,#83,#1C,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#EE,#0F
db #0F,#83,#1C,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#EE,#0F
db #0F,#80,#10,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#EE,#0F
db #0F,#F0,#F0,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#CF,#3F,#FF,#FF,#FF,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#88,#00,#00,#62,#00,#00,#10,#88,#00,#00,#62,#00,#00,#10,#88,#00,#00,#43,#2E,#00,#00,#10,#0F,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#FF,#0F
db #0F,#98,#80,#60,#62,#70,#00,#10,#98,#C0,#E0,#62,#30,#F0,#10,#98,#80,#60,#43,#2E,#00,#C0,#10,#0F,#88,#00,#00,#00,#00,#10,#88,#00,#00,#00,#00,#10,#0F
db #0F,#98,#90,#E0,#62,#70,#E0,#10,#98,#C0,#E0,#62,#30,#F0,#10,#98,#E0,#60,#43,#2E,#10,#E0,#10,#0F,#BB,#CC,#D0,#00,#00,#90,#B8,#C0,#80,#F0,#F0,#D0,#0F
db #0F,#98,#B0,#E0,#62,#70,#F0,#90,#98,#C0,#E0,#62,#30,#F0,#10,#98,#F0,#60,#43,#2E,#30,#F0,#10,#0F,#BB,#DC,#90,#90,#50,#10,#B8,#D0,#C0,#00,#00,#50,#0F
db #0F,#98,#B0,#E0,#62,#70,#F0,#90,#98,#C0,#E0,#62,#30,#F0,#10,#98,#F0,#60,#43,#2E,#70,#F0,#90,#0F,#BB,#CC,#50,#50,#50,#90,#B8,#C0,#80,#00,#00,#50,#0F
db #0F,#98,#90,#E0,#62,#70,#E0,#10,#98,#C0,#E0,#62,#30,#F0,#10,#98,#E0,#60,#43,#2E,#00,#00,#10,#0F,#BB,#DC,#90,#40,#90,#10,#B8,#C0,#F0,#F0,#F0,#D0,#0F
db #0F,#98,#80,#60,#62,#70,#00,#10,#98,#C0,#E0,#62,#30,#F0,#10,#98,#80,#60,#43,#2E,#70,#F0,#90,#0F,#88,#00,#00,#00,#00,#10,#88,#00,#00,#00,#00,#10,#0F
db #0F,#88,#00,#00,#62,#00,#00,#10,#88,#00,#00,#62,#00,#00,#10,#88,#00,#00,#43,#2E,#00,#00,#10,#0F,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#0F
db #0F,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#F0,#C3,#3C,#F0,#F0,#F0,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F
db #0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F,#0F


;==============================================================================
;### TRANSFER-TEIL ############################################################
;==============================================================================

prgtrnbeg

;### PRGPRZS -> Stack fr Programm-Prozess
        ds 128
prgstk  ds 6*2
        dw prgprz
prgprzn db 0
prgmsgb ds 14

;### PRGTIMS -> Stack fr Programm-Timer
        ds 128
prgtims ds 6*2
        dw prgtim
prgtimn db 0
timmsgb ds 14

cfgcpctyp   db 0

;### INFO-FENSTER #############################################################

prgmsginf  dw prgmsginf1,4*1+2,prgmsginf2,4*1+2,prgmsginf3,4*1+2,prgicnbig

;### HAUPT-FENSTER ############################################################

prgwindat dw #3501,0,171,104,148,62,0,0,148,62,148,62,148,62,prgicnsml,prgwintit,0,prgwinmen,prgwingrp,0,0:ds 136+14

prgwinmen  dw 5, 1+4,prgwinmentx1,prgwinmen1,0, 1+4,prgwinmentx2,prgwinmen2,0, 1+4,prgwinmentx3,prgwinmen3,0, 1+4,prgwinmentx4,prgwinmen4,0, 1+4,prgwinmentx5,prgwinmen5,0
prgwinmen1 dw 7, 1,prgwinmen1tx1,ctlopn,0, 1,prgwinmen1tx2,prpsng,0, 1+8,0,0,0, 1,prgwinmen1tx3,lstlod,0, 1,prgwinmen1tx4,lstsav,0, 1+8,0,0,0, 1,prgwinmen1tx5,prgend,0
prgwinmen2 dw 8, 1,prgwinmen2tx1,ctlrew,0, 1,prgwinmen2tx2,ctlply,0, 1,prgwinmen2tx3,ctlpau,0, 1,prgwinmen2tx4,ctlstp,0, 1,prgwinmen2tx5,ctlffw,0, 1+8,0,0,0
prgwinmen2a   dw 1,prgwinmen2tx6,ctlrep,0
prgwinmen2b   dw 1,prgwinmen2tx7,ctlshu,0
prgwinmen3 dw 2, 1,prgwinmen3tx1,mixopn,0, 0,prgwinmen3tx2,00,0
prgwinmen4 dw 1, 1,prgwinmen4tx1,lstswt,0
prgwinmen5 dw 3, 1,prgwinmen5tx1,hlpopn,0, 1+8,0,0,0, 1,prgwinmen5tx2,prginf,0

prgwingrp db 24,0:dw prgwinobj,0,0,0,0,0,0
prgwinobj
dw     00,255*256+08,gfxbgr    ,  0, 0,148, 62,0    ;00=Hintergrund
dw     00,255*256+01,prgwindsc1, 16,10, 30, 08,0    ;01=PlayZeit Display
dw     00,255*256+08
prgwinobj1        dw gfxstp,      8,10, 08, 08,0    ;02=PlayModus
dw     00,255*256+01,prgwindsc2, 56, 5, 86, 08,0    ;03=SoundName Display
dw     00,255*256+01,prgwindsc3, 56,17, 18, 08,0    ;04=KbpS Display
dw     00,255*256+01,prgwindsc4,104,17, 18, 08,0    ;05=KHz Display
dw ctlvol,255*256+02,256*01+3+64+128, 54,28,48,06,0 ;06=Display Lautstrke
dw ctlvol,255*256+08,gfxsld
prgwinobj4                    dw 94,28,  8, 06,0    ;07=Slider  Lautstrke
dw ctlpan,255*256+02,256*01+3+64+128,106,28,20,06,0 ;08=Display Panning
dw ctlpan,255*256+08,gfxsld
prgwinobj5                    dw 112,28, 8, 06,0    ;09=Slider  Panning
dw ctlpos,255*256+02,256*01+3+64+128, 4,38,140,06,0 ;10=Display Position
dw     00,255*256+08,gfxsld
prgwinobj2                    dw  4,38,  8, 06,0    ;11=Slider  Position
prgwinobj3
dw     00,255*256+00,1         , 98,51,  4,  4,0    ;12=Display Shuffle
dw     00,255*256+00,1         ,122,51,  4,  4,0    ;13=Display Repeat
dw anaswt,255*256+08,gfxana1   ,  8,20, 40, 12,0    ;14=Frequenz-Analyzer
dw ctlrew,255*256+19,0         , 04,48, 14, 10,0    ;15=Button Zurck
dw ctlply,255*256+19,0         , 18,48, 14, 10,0    ;16=Button Play
dw ctlpau,255*256+19,0         , 32,48, 14, 10,0    ;17=Button Pause
dw ctlstp,255*256+19,0         , 46,48, 14, 10,0    ;18=Button Stop
dw ctlffw,255*256+19,0         , 60,48, 14, 10,0    ;19=Button Vorwrts
dw ctlopn,255*256+19,0         , 78,48, 14, 10,0    ;20=Button Auswerfen
dw ctlshu,255*256+19,0         , 96,48, 24, 10,0    ;21=Button Shuffle
dw ctlrep,255*256+19,0         ,120,48, 24, 10,0    ;22=Button Repeat
dw lstswt,255*256+19,0         ,129,27, 14, 10,0    ;23=Button Playlist

prgwindsc1  dw prgwintxt1,1+0+512
prgwindsc2  dw prgwintxt0,1+0+128
prgwindsc3  dw prgwintxt3,1+0+128+512
prgwindsc4  dw prgwintxt4,1+0+128+512

;### PLAYLIST #################################################################

prglstdat   dw #3701,5,171,0,140,54,0,0,140,162,96,24,1000,1000,prgicnsml,prglsttit,0,prglstmen,prglstgrp,0,0:ds 136+14

prglstmen  dw 6, 1+4,prglstmentx1,prglstmen1,0, 1+4,prglstmentx2,prglstmen2,0, 1+4,prglstmentx3,prglstmen3,0, 1+4,prglstmentx4,prglstmen4,0, 1,prglstmentx5,lsteup,0, 1,prglstmentx6,lstedw,0
prglstmen1 dw 2, 1,prglstmen1tx1,lstafi,0, 1,prglstmen1tx2,lstadi,0
prglstmen2 dw 2, 1,prglstmen2tx1,lstrsl,0, 1,prglstmen2tx2,lstral,0
prglstmen3 dw 3, 1,prglstmen3tx1,lstsal,0, 1,prglstmen3tx2,lstsno,0, 1,prglstmen3tx3,lstsiv,0
prglstmen4 dw 4, 1,prglstmen4tx1,prplst,0, 1+8,0,0,0, 1,prgwinmen1tx3,lstlod,0, 1,prgwinmen1tx4,lstsav,0

prglstgrp   db 2,0:dw prglstobj,prglstclc,0,00,0,0,0
prglstobj
dw 00,     255*256+0, 0,           0,0,0,1000,0     ;00=Hintergrund
dw lstclk, 255*256+41,prgobjlst1,  0,0,0, 162,0     ;01=Liste Eintrge
prglstclc
dw 0,0,0,0,1000,0,1000,0
dw 0 , 0,0,0, 0,256+1,162,0

prgobjlst1  dw 0,0,lstentlst,0,256*0+1,lstentrow,0,2
lstentrow   dw 0,1000,00,0
lstentlst   dw 00,00,01,00,02,00,03,00,04,00,05,00,06,00,07,00,08,00,09,00
            dw 10,00,11,00,12,00,13,00,14,00,15,00,16,00,17,00,18,00,19,00
            dw 20,00,21,00,22,00,23,00,24,00,25,00,26,00,27,00,28,00,29,00
            dw 30,00,31,00,32,00,33,00,34,00,35,00,36,00,37,00,38,00,39,00
            dw 40,00,41,00,42,00,43,00,44,00,45,00,46,00,47,00,48,00,49,00
            dw 50,00,51,00,52,00,53,00,54,00,55,00,56,00,57,00,58,00,59,00
            dw 60,00,61,00,62,00,63,00,64,00,65,00,66,00,67,00,68,00,69,00
            dw 70,00,71,00,72,00,73,00,74,00,75,00,76,00,77,00,78,00,79,00
            dw 80,00,81,00,82,00,83,00,84,00,85,00,86,00,87,00,88,00,89,00
            dw 90,00,91,00,92,00,93,00,94,00,95,00,96,00,97,00,98,00

;### PROPERTY FENSTER #########################################################

properwin   dw #1401,4+16,059,011,200,114,0,0,200,114,200,114,200,114,0,propertit,0,0,propergrp,0,0:ds 136+14
propergrp   db 19,0:dw properdat,0,0,256*8+8,0,0,0
properdat
dw      00,         0,2,          0,0,1000,1000,0       ;00=Hintergrund
dw      00,255*256+ 1,properdsc1a,05, 07, 55, 8,0       ;01=Beschreibung "File"
dw      00,255*256+ 1,properdsc1b,51, 07,104,12,0       ;02=Angabe       "File"
dw      00,255*256+ 1,properdsc2a,05, 17, 55, 8,0       ;03=Beschreibung "Type"
dw      00,255*256+ 1,properdsc2b,51, 17,104,12,0       ;04=Angabe       "Type1"
dw      00,255*256+ 1,properdsc2c,51, 27,104,12,0       ;05=Angabe       "Type2"
dw      00,         0,1,          05, 38,190, 1,0       ;06=Trennlinie
dw  diacnc,255*256+16,prgtxtok,  147, 97, 48,12,0       ;07="Cancel"-Button
dw      00,255*256+ 1,properdsc3a,05, 42, 55, 8,0       ;08=Beschreibung "Title"
dw      00,255*256+ 1,properdsc3b,51, 42,104,12,0       ;09=Angabe       "Title"
dw      00,255*256+ 1,properdsc4a,05, 52, 55, 8,0       ;10=Beschreibung "Artist"
dw      00,255*256+ 1,properdsc4b,51, 52,104,12,0       ;11=Angabe       "Artist"
dw      00,255*256+ 1,properdsc5a,05, 62, 55, 8,0       ;12=Beschreibung "Album"
dw      00,255*256+ 1,properdsc5b,51, 62,104,12,0       ;13=Angabe       "Album"
dw      00,255*256+ 1,properdsc6a,05, 72, 55, 8,0       ;14=Beschreibung "Year"
dw      00,255*256+ 1,properdsc6b,51, 72,104,12,0       ;15=Angabe       "Year"
dw      00,255*256+ 1,properdsc7a,05, 82, 55, 8,0       ;16=Beschreibung "Comment"
dw      00,255*256+ 1,properdsc7b,51, 82,104,12,0       ;17=Angabe       "Comment"
dw      00,         0,1,          05, 93,190, 1,0       ;18=Trennlinie

properdsc1a dw propertxt1a,2+4
properdsc1b dw propertxt10,2+4
properdsc2a dw propertxt2a,2+4
properdsc2b dw 00         ,2+4
properdsc2c dw 00         ,2+4
properdsc3a dw propertxt3a,2+4
properdsc3b dw propertxt3b,2+4
properdsc4a dw propertxt4a,2+4
properdsc4b dw propertxt4b,2+4
properdsc5a dw propertxt5a,2+4
properdsc5b dw propertxt5b,2+4
properdsc6a dw propertxt6a,2+4
properdsc6b dw propertxt6b,2+4
properdsc7a dw propertxt7a,2+4
properdsc7b dw propertxt7b,2+4

;### MIXER-SETTINGS ###########################################################

prgwinmix dw #1501,0,80,10,128,113,0,0,128,113,128,113,128,113, prgicnsml,prgtitmix,0,0,prggrpmix,0,0:ds 136+14
prggrpmix db 12,0:dw prgdatmix,0,0,2*256+2,0,0,0
prgdatmix
dw 00,     255*256+0,2, 0,0,1000,1000,0                 ;00=Hintergrund
dw mixclo, 255*256+16,prgtxtok,    44,98,40,12,0        ;01="Ok"-Button
dw 00,     255*256+3, mixobjdat1,  0, 1,128,38,0        ;02=Rahmen Equalizer
dw 00,     255*256+1, mixobjdata,  8, 12,30,8,0         ;03=Equalizer "Bass"   Text
dw mixset0,255*256+24,mixobjdatb, 40, 12,80,8,0         ;04=Equalizer "Bass"   Slider
dw 00,     255*256+1, mixobjdatd,  8, 23,30,8,0         ;05=Equalizer "Treble" Text
dw mixset0,255*256+24,mixobjdate, 40, 23,80,8,0         ;06=Equalizer "Treble" Slider
dw 00,     255*256+3, mixobjdat2,  0,39,128,58,0        ;07=Rahmen Soundmode
dw mixset0,255*256+18,mixobjdatj,  8, 50,112,8,0        ;08=Soundmode "Mono" Radio
dw mixset0,255*256+18,mixobjdatk,  8, 60,112,8,0        ;09=Soundmode "Stereo" Radio
dw mixset0,255*256+18,mixobjdatl,  8, 70,112,8,0        ;10=Soundmode "Pseudo Stereo" Radio
dw mixset0,255*256+18,mixobjdatm,  8, 80,112,8,0        ;11=Soundmode "Spatial Stereo" Radio

mixobjdat1 dw mixobjtxt1,2+4
mixobjdat2 dw mixobjtxt2,2+4

mixobjdata dw mixobjtxta,2+4
mixobjdatb dw 1,120,255,256*248+8
mixobjdatd dw mixobjtxtd,2+4
mixobjdate dw 1,120,255,256*248+8

mixobjdatj dw mixobjdats,mixobjtxtj,256*0+2+4,mixobjdatkr
mixobjdatk dw mixobjdats,mixobjtxtk,256*1+2+4,mixobjdatkr
mixobjdatl dw mixobjdats,mixobjtxtl,256*2+2+4,mixobjdatkr
mixobjdatm dw mixobjdats,mixobjtxtm,256*3+2+4,mixobjdatkr
mixobjdats db 1
mixobjdatkr ds 4

;### ERROR-FENSTER ############################################################

prgmsgerr  dw sysmsglod1,4*1+2,sysmsglod2,4*1+2,prgwintxt0,4*1+2

;### SOUND PFAD UND NAME ######################################################

sndmsk  db "*  ",0
sndfil  ds 256+1

lstmsk  db "*  ",0
lstfil  ds 256+1

splmsk  db "spl",0
splfil  ds 256+1

;### Playliste
lstmax  equ 1700
lstnam  ds 17
;--- BEG songlist filedata
lstpth  ds 256+1
lstanz  db 0
lstmem  ds 5        ;##!! LETZTER LABEL !!##
;--- END songlist filedata

prgtrnend

relocate_table
relocate_end
